/*
 * RCS Info
 * $Id: admsCheck.c,v 1.13 2006/01/26 13:39:25 r29173 Exp $
 * 
 * Log
 * $Log: admsCheck.c,v $
 * Revision 1.13  2006/01/26 13:39:25  r29173
 * fixed core dump when running admsCheck
 *
 * Revision 1.12  2005/06/21 08:02:28  r29173
 * renamed adms_set_admsmain to adms_valueto_admsmain
 *
 * Revision 1.11  2005/05/09 14:38:29  r29173
 * cleaned-up source directory structure
 *
 * Revision 1.10  2005/05/03 09:35:14  r29173
 * cleaned-up header file dependencies
 *
 * Revision 1.9  2005/05/03 07:58:19  r29173
 * moved admsNS into admsFile
 *
 * Revision 1.8  2005/04/01 07:25:44  r29173
 * renamed prefix .xsl to .xml
 *
 * Revision 1.7  2005/01/11 09:58:01  r29173
 * tons of changes - simplify accessor names (valueof, valueto)
 *
 * Revision 1.6  2004/11/19 12:29:56  r29173
 * renamed _C into CAT
 * saved argc, argv into admsmain element
 * added adms:setenv transform
 *
 * Revision 1.5  2004/11/11 13:45:03  r29173
 * replaced g_message by adms_message_info
 *
 * Revision 1.4  2004/11/01 09:37:36  r29173
 * changed messaging macros (avoid useless computation of arguments)
 * improved the coding of transforms in xmlProgram.c
 *
 * Revision 1.3  2004/08/03 12:33:54  r29173
 * import adms-1.21.0 from local CVS
 *
 * Revision 1.2  2004/08/03 10:05:46  r29173
 * removed superelement from admsgui
 * fixed some warnings issued during compilation
 *
 * Revision 1.1.1.1  2004/05/21 12:20:01  r29173
 * recreated cvs data structure (crashed after revision 1.13.0!)
 *
 * Revision 1.10  2004/03/11 16:25:14  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.9  2004/03/08 13:58:05  r29173
 * all code lower-cased
 *
 * Revision 1.8  2004/03/08 08:24:19  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.7  2004/01/13 11:25:51  r29173
 * added adms_message_usage
 *
 * Revision 1.6  2004/01/09 16:23:45  r29173
 * cleaned-up use of #include
 *
 * Revision 1.5  2004/01/08 10:28:49  r29173
 * moved code to always.[ch]
 *
 * Revision 1.4  2004/01/05 11:07:51  r29173
 * change the way admsCheck.xml is downloaded
 *
 * Revision 1.3  2003/10/22 15:11:36  r29173
 * changed the way script "text2Ccode.pl" handles file name.
 *
 * Revision 1.2  2003/05/21 14:18:00  r29173
 * add rcs info
 *
 */

#include <admsObject/admsC.h>
#include <admsCheck/admsCheck.h>

_t_file_usage_static (adms_check_usage)
{
  adms_message_usage ("%s [options]\n",g_get_prgname())
}
int main (const int argc, const char **argv)
{
  g_log_set_always_fatal (G_LOG_LEVEL_CRITICAL);
  g_set_prgname (g_strconcat(PACKAGE_NAME, "Check", NULL));
  adms_valueto_admsmain (argc,argv);
  adms_admsmain_valueto_filename (adms_get_admsmain (),g_strdup("stdin"));

  if(adms_file_check_command_line (argc, argv, adms_check_usage))
    return 0;

  g_set_print_handler ((GPrintFunc) adms_file_filehandling_print);
  adms_message_info ("Working directory: %s\n", g_get_current_dir ());
  adms_check_read_xml ();
  adms_message_info ("How to run the example\n");
  adms_message_info ("     admsXml VBICSELFT.va -e basicLibrary.xml -e spectreMODULE_dc.ckt.xml\n");
  adms_message_info ("     This command parses file VBICSELFT.va\n");
  adms_message_info ("     and interprets scripts basicLibrary.xml and spectremodule_dc.ckt.xml\n");
  adms_message_info ("     (file .VBICSELFT.va.adms is created in background).\n");

  return 0;
}
