/*
 * RCS Info
 * $Id: admsPreprocessor.h,v 1.6 2005/11/08 14:07:59 r29173 Exp $
 * 
 * Log
 * $Log: admsPreprocessor.h,v $
 * Revision 1.6  2005/11/08 14:07:59  r29173
 * fixed bug (skipp_text becomes a list)
 *
 * Revision 1.5  2005/05/03 07:58:21  r29173
 * moved admsNS into admsFile
 *
 * Revision 1.4  2004/11/19 12:29:56  r29173
 * renamed _C into CAT
 * saved argc, argv into admsmain element
 * added adms:setenv transform
 *
 * Revision 1.3  2004/08/03 12:33:55  r29173
 * import adms-1.21.0 from local CVS
 *
 * Revision 1.2  2004/05/26 13:02:48  r29173
 * added default values to all enumerations
 *
 * Revision 1.1.1.1  2004/05/21 12:20:01  r29173
 * recreated cvs data structure (crashed after revision 1.13.0!)
 *
 * Revision 1.11  2004/03/08 13:58:06  r29173
 * all code lower-cased
 *
 * Revision 1.10  2004/02/06 09:06:03  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.9  2004/01/16 10:31:26  r29173
 * added YYDEBUG=1
 *
 * Revision 1.8  2004/01/09 16:23:47  r29173
 * cleaned-up use of #include
 *
 * Revision 1.7  2004/01/06 14:13:13  r29173
 * fixed definition of win32_interface
 *
 * Revision 1.6  2004/01/06 12:35:28  r29173
 * fixed the use of globals: input file and output file
 *
 * Revision 1.5  2004/01/05 11:38:48  r29173
 * removed unused code
 *
 * Revision 1.4  2003/12/11 16:10:11  r29173
 * changed usage of win32_interface
 *
 * Revision 1.3  2003/12/11 16:01:53  r29173
 * changed prefix [epst]_adms_ to [epst]_
 *
 * Revision 1.2  2003/05/21 14:18:01  r29173
 * add rcs info
 *
 */

#ifndef _preprocessor_main_included
#define _preprocessor_main_included

#include <admsFile/admsFile.h>

#undef win32_interface
#if defined(WIN32)
#  if defined(_inside_admsPreprocessor)
#    define win32_interface __declspec(dllexport)
#  else
#    define win32_interface __declspec(dllimport)
#  endif
#else
#  define win32_interface extern
#endif

#define last_char(s)  s+(strlen(s)-1) 

win32_interface void adms_preprocessor_get_define_from_argv(const int argc,const char**argv);

win32_interface int adms_preprocessor_getint_yydebug (void);
win32_interface void adms_preprocessor_setint_yydebug (const int val);

win32_interface FILE *adms_preprocessor_in;
win32_interface FILE *adms_preprocessor_out;

win32_interface int adms_preprocessor_registration_printf (const gchar *filename);

typedef struct s_preprocessor t_preprocessor;
typedef t_preprocessor*       p_preprocessor;
struct s_preprocessor {
  gpointer * buffer;
  gchar * filename;
  FILE * fid;
  gint cur_line_position;
  gint cur_char_position;
  gchar * cur_message;
  GSList * cur_continuator_position;
};

typedef struct s_preprocessor_pragma_define_text t_preprocessor_pragma_define_text;
typedef t_preprocessor_pragma_define_text*       p_preprocessor_pragma_define_text;
struct s_preprocessor_pragma_define_text {
  gchar * name;
  gint isArg;
};

typedef struct s_preprocessor_pragma_define t_preprocessor_pragma_define;
typedef t_preprocessor_pragma_define*       p_preprocessor_pragma_define;
struct s_preprocessor_pragma_define {
  gchar * name;
  gboolean hasArg;
  gboolean isDefined;
  GSList * arg;
  GSList * text;
};

typedef struct s_preprocessor_substitutor t_preprocessor_substitutor;
typedef t_preprocessor_substitutor*       p_preprocessor_substitutor;
typedef struct s_preprocessor_text t_preprocessor_text;
typedef t_preprocessor_text*       p_preprocessor_text;

struct s_preprocessor_substitutor {
  p_preprocessor_pragma_define _pragma;
  GSList * _newarg;
  GSList * _newtext;
  p_preprocessor_text _cr_text;
  GSList * _cr_newarg;
};

struct s_preprocessor_text {
  gboolean _isarg;
  gchar * _str;
};

typedef struct s_preprocessor_main t_preprocessor_main;
typedef t_preprocessor_main*       p_preprocessor_main;
struct s_preprocessor_main {
  p_preprocessor cr_scanner;
  gchar * cr_filename;
  GSList * Scanner;
  GSList * Text;
  GSList * Defined;
  GSList * includePath;
  GSList * skipp_text;
  gint error;
};

win32_interface void adms_preprocessor_new (void);
win32_interface p_preprocessor_main adms_preprocessor_get_main (void);

win32_interface int adms_preprocessor_lex ();

win32_interface void adms_preprocessor_error (const char *s);

win32_interface int adms_preprocessor_parse ();

typedef struct s_continuator t_continuator;
typedef t_continuator*       p_continuator;
struct s_continuator {
  gint line_position;
  gint char_position;
};

win32_interface gint adms_preprocessor_get_char_position (p_preprocessor cr_preprocessor);
win32_interface gint adms_preprocessor_get_line_position (p_preprocessor cr_preprocessor, gint char_pos);

win32_interface gboolean adms_preprocessor_add_message ( gchar *message);

win32_interface p_preprocessor_pragma_define adms_preprocessor_define_add (gchar * name);
win32_interface gboolean adms_preprocessor_define_add_default (gchar * name);
win32_interface gboolean adms_preprocessor_define_add_default_with_text (gchar * name, gchar * value);
win32_interface p_preprocessor_pragma_define adms_preprocessor_undefine_add (gchar * name);
win32_interface p_preprocessor_pragma_define adms_preprocessor_define_add_with_text (gchar * name, GSList * text);
win32_interface p_preprocessor_pragma_define adms_preprocessor_define_add_with_arg (gchar * name, GSList * arg);
win32_interface p_preprocessor_pragma_define adms_preprocessor_define_add_with_arg_and_text (gchar * name, GSList * arg, GSList * text);

win32_interface p_preprocessor_pragma_define adms_preprocessor_pragma_define_exists (gchar * name);

win32_interface gboolean adms_preprocessor_identifier_is_def (gchar * name);
win32_interface gboolean adms_preprocessor_identifier_is_ndef (gchar * name);

win32_interface p_preprocessor_pragma_define adms_preprocessor_identifer_set_undef (gchar * name);

win32_interface gboolean adms_preprocessor_pragma_define_is_def (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_is_ndef (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_arg (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_noarg (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_nullarg (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_text (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_notext (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_noarg_and_notext (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_noarg_and_text (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_nullarg_and_notext (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_nullarg_and_text (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_arg_and_notext (p_preprocessor_pragma_define pragma);
win32_interface gboolean adms_preprocessor_pragma_define_has_arg_and_text (p_preprocessor_pragma_define pragma);

win32_interface p_preprocessor_text adms_preprocessor_new_text_as_string(gchar *name);
win32_interface GSList *adms_preprocessor_new_text_as_substitutor
  (p_preprocessor_pragma_define define, GSList * newarg);

win32_interface gboolean adms_preprocessor_text_list_printf(GSList *text);

win32_interface gint adms_preprocessor_get_line_position_with_error (p_preprocessor cr_preprocessor);

win32_interface void adms_preprocessor_setfile_input (FILE *ifile);
win32_interface FILE *adms_preprocessor_getfile_input (void);
win32_interface void adms_preprocessor_setfile_output (FILE *ifile);
win32_interface FILE *adms_preprocessor_getfile_output (void);

#endif /* _preprocessor_main_included */
