/*
 * RCS Info
 * $Id: preprocessorMain.c,v 1.12 2005/06/17 16:44:25 r29173 Exp $
 * 
 * Log
 * $Log: preprocessorMain.c,v $
 * Revision 1.12  2005/06/17 16:44:25  r29173
 * debug memory allocation with valgrind
 *
 * Revision 1.11  2005/06/16 07:12:45  r29173
 * debug memory allocation with valgrind
 *
 * Revision 1.10  2005/05/09 14:38:30  r29173
 * cleaned-up source directory structure
 *
 * Revision 1.9  2005/05/03 09:35:15  r29173
 * cleaned-up header file dependencies
 *
 * Revision 1.8  2005/05/03 07:58:21  r29173
 * moved admsNS into admsFile
 *
 * Revision 1.7  2004/11/19 12:29:56  r29173
 * renamed _C into CAT
 * saved argc, argv into admsmain element
 * added adms:setenv transform
 *
 * Revision 1.6  2004/11/01 09:37:37  r29173
 * changed messaging macros (avoid useless computation of arguments)
 * improved the coding of transforms in xmlProgram.c
 *
 * Revision 1.5  2004/10/20 15:33:52  r29173
 * tons of changes
 * 1- introduced element whileloop (marat)
 * 2- reshaped the handling of the messaging system
 * 3- fixed bug in admsCheck/Makefile.am
 * 4- started implementation of implicit adms transforms
 *
 * Revision 1.4  2004/08/19 16:45:47  r29173
 * cleaned-up i/o file handling
 *
 * Revision 1.3  2004/08/03 12:33:55  r29173
 * import adms-1.21.0 from local CVS
 *
 * Revision 1.3  2004/07/09 14:39:11  r29173
 * removed data structure ns
 *
 * Revision 1.2  2004/05/26 13:02:48  r29173
 * added default values to all enumerations
 *
 * Revision 1.1.1.1  2004/05/21 12:20:01  r29173
 * recreated cvs data structure (crashed after revision 1.13.0!)
 *
 * Revision 1.14  2004/03/08 13:58:06  r29173
 * all code lower-cased
 *
 * Revision 1.13  2004/02/13 14:28:39  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.12  2004/02/06 09:06:03  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.11  2004/01/21 14:35:47  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.10  2004/01/09 16:23:47  r29173
 * cleaned-up use of #include
 *
 * Revision 1.9  2004/01/08 10:28:50  r29173
 * moved code to always.[ch]
 *
 * Revision 1.8  2004/01/06 12:35:29  r29173
 * fixed the use of globals: input file and output file
 *
 * Revision 1.7  2003/12/12 15:08:35  r29173
 * changed construct (a==NULL) to (!a)
 *
 * Revision 1.6  2003/12/12 14:43:38  r29173
 * changed construct (a==NULL) to (!a)
 *
 * Revision 1.5  2003/12/12 14:33:26  r29173
 * changed construct (a!=NULL) into (a) or (a)?1:0
 *
 * Revision 1.4  2003/12/11 20:14:07  r29173
 * cleaned-up after compilation with CFLAG+=-Wall
 *
 * Revision 1.3  2003/12/11 16:01:53  r29173
 * changed prefix [epst]_adms_ to [epst]_
 *
 * Revision 1.2  2003/05/21 14:18:01  r29173
 * add rcs info
 *
 */

#include <admsPreprocessor/admsPreprocessor.h>
#include <admsObject/admsC.h>

#define strdup_before_ptr(s,sptr,offset) g_strndup(s+offset,sptr-s-offset)
#define strdup_after_ptr(s,sptr,offset)  g_strndup(sptr+offset,strlen(s)-(sptr-s)-offset)

extern int adms_preprocessor_leng;
static p_preprocessor_main adms_preprocessor_main;
void adms_preprocessor_new ()
{
  adms_preprocessor_main = g_new0(t_preprocessor_main,1);
}
p_preprocessor_main adms_preprocessor_get_main ()
{
  return adms_preprocessor_main;
}
void adms_preprocessor_get_define_from_argv (const gint argc,const char ** argv)
{
  int i;
  for (i=1; i<argc; i++)
  {
    char *value = g_strdup (argv[i]);
    char *defineName = NULL;
    char *defineValue = NULL;
    if ( (strlen(value)>2) && ((value[0])=='-') && ((value[1])=='D') )
    {
      char *equal = NULL;
      char *arg = strdup_after_ptr (value,value+2,0);
      char *argPtr = arg;
      while (argPtr && (!equal))
      {
        if (*argPtr=='=')
          equal= argPtr;
        argPtr++;
      }
      if (*arg == '=')
        adms_message_verbose("at command line argument, bad syntax ... '%s'\n",value)
      else if (equal == last_char (arg))
        defineName = strdup_before_ptr (arg,equal,0);
      else if (!equal)
        defineName = g_strdup (arg);
      else
      {
        defineName = strdup_before_ptr (arg,equal,0);
        defineValue = strdup_after_ptr (arg,equal,1);
      }
      if (defineName)
      {
        if (defineValue)
          adms_preprocessor_define_add_default_with_text (defineName, defineValue);
        else
          adms_preprocessor_define_add_default (defineName);
      }
      free(arg);
    }
    if (defineName)
      adms_message_verbose("setting pragma ... '%s'\n",defineName)
    free(value);
  }
}
gboolean adms_preprocessor_add_message ( gchar *message)
{
  adms_message_info (message)
  return FALSE;
}
static GFunc adms_preprocessor_text_printf(p_preprocessor_text text)
{
  g_print("%s",text->_str);
  return FALSE;
}
gboolean adms_preprocessor_text_list_printf(GSList *text)
{
  g_slist_foreach (text, (GFunc) adms_preprocessor_text_printf, NULL);
  return FALSE;
}
p_preprocessor_text adms_preprocessor_new_text_as_string(gchar *name)
{
  p_preprocessor_text text = g_new0(t_preprocessor_text,1);
  text->_str = name;
  return text;
}
static GFunc adms_preprocessor_pragma_substitute_text_cb_cb (gchar * arg, p_preprocessor_substitutor substitutor)
{
  gboolean stop = FALSE;
  if ( !strcmp(substitutor->_cr_text->_str,arg) )
  {
    if (substitutor->_cr_newarg)
    {
      GSList *newarg = g_slist_copy(substitutor->_cr_newarg->data);
      newarg = g_slist_reverse (newarg);
      substitutor->_newtext = g_slist_concat (newarg, substitutor->_newtext);
    }
    else
      qpush(&(substitutor->_newtext),substitutor->_cr_text);
    stop = TRUE;
  }
  substitutor->_cr_newarg = g_slist_next (substitutor->_cr_newarg);
  if(!(substitutor->_cr_newarg))
    stop = TRUE;
  return GINT_TO_POINTER(FALSE);
}
static GFunc adms_preprocessor_pragma_substitute_text_cb (p_preprocessor_text text, p_preprocessor_substitutor substitutor)
{
  GSList *arg = g_slist_copy(substitutor->_pragma->arg);
  substitutor->_cr_text = text;
  arg = g_slist_reverse(arg);
  substitutor->_cr_newarg = g_slist_copy(substitutor->_newarg);
  substitutor->_cr_newarg = g_slist_reverse(substitutor->_cr_newarg);
  if (text->_isarg == TRUE)
    g_slist_foreach ( arg, (GFunc) adms_preprocessor_pragma_substitute_text_cb_cb , substitutor);
  else
  {
    p_preprocessor_text newtext = adms_preprocessor_new_text_as_string(text->_str);
    newtext->_isarg = -1;
    qpush(&(substitutor->_newtext),newtext);
  }
  g_slist_free(arg);
  g_slist_free(substitutor->_cr_newarg);
  return GINT_TO_POINTER(FALSE);
}
static gboolean adms_preprocessor_pragma_substitute_text (p_preprocessor_substitutor substitutor)
{
  if (adms_preprocessor_pragma_define_is_def (substitutor->_pragma))
  {
    p_preprocessor_text space = adms_preprocessor_new_text_as_string(" ");
    g_slist_foreach ( substitutor->_pragma->text, (GFunc) adms_preprocessor_pragma_substitute_text_cb,  substitutor);
    qpush(&(substitutor->_newtext),space);
  }
  else
  {
    p_preprocessor_text name = adms_preprocessor_new_text_as_string(substitutor->_pragma->name);
    qpush(&(substitutor->_newtext),name);
  }
  return FALSE;
}
GSList *adms_preprocessor_new_text_as_substitutor (p_preprocessor_pragma_define define, GSList * newarg)
{
  p_preprocessor_substitutor substitutor = g_new0(t_preprocessor_substitutor,1);
  substitutor->_pragma = define;
  substitutor->_newarg = newarg;
  adms_preprocessor_pragma_substitute_text(substitutor);
  substitutor->_newtext = g_slist_reverse (substitutor->_newtext);
  return substitutor->_newtext;
}
gboolean adms_preprocessor_pragma_define_has_arg (p_preprocessor_pragma_define pragma)
{
  return (pragma->hasArg==TRUE);
}
gboolean adms_preprocessor_pragma_define_is_def (p_preprocessor_pragma_define pragma)
{
  return (pragma->isDefined==TRUE);
}
gboolean adms_preprocessor_identifier_is_def (gchar * name)
{
  gboolean test;
  p_preprocessor_pragma_define pragma;
  if(
      (pragma = adms_preprocessor_pragma_define_exists (name))
      &&
      adms_preprocessor_pragma_define_is_def(pragma)
    )
    test = ( pragma->isDefined == TRUE );
  else
    test = FALSE;
  return test;
}
p_preprocessor_pragma_define adms_preprocessor_identifer_set_undef (gchar * name)
{
  p_preprocessor_pragma_define pragma = adms_preprocessor_pragma_define_exists (name);
  if(!pragma)
    pragma = adms_preprocessor_define_add (name);
  pragma->isDefined = FALSE;
  return pragma;
}
gboolean adms_preprocessor_identifier_is_ndef (gchar * name)
{
  return (!adms_preprocessor_identifier_is_def (name) );
}
gboolean adms_preprocessor_pragma_define_is_ndef (p_preprocessor_pragma_define pragma)
{
  return (!adms_preprocessor_pragma_define_is_def(pragma));
}
gboolean adms_preprocessor_pragma_define_has_noarg (p_preprocessor_pragma_define pragma)
{
  return (!adms_preprocessor_pragma_define_has_arg(pragma));
}
gboolean adms_preprocessor_pragma_define_has_nullarg (p_preprocessor_pragma_define pragma)
{
  return adms_preprocessor_pragma_define_has_arg(pragma) && (g_slist_length( pragma->arg )==0);
}
gboolean adms_preprocessor_pragma_define_has_text (p_preprocessor_pragma_define pragma)
{
  return ((pragma->text)?1:0);
}
gboolean adms_preprocessor_pragma_define_has_notext (p_preprocessor_pragma_define pragma)
{
  return (!adms_preprocessor_pragma_define_has_text(pragma));
}
gboolean adms_preprocessor_pragma_define_has_noarg_and_notext (p_preprocessor_pragma_define pragma)
{
  gboolean test;
  test = adms_preprocessor_pragma_define_has_noarg(pragma)
         &&
         adms_preprocessor_pragma_define_has_notext(pragma)
         ;
  return test;
}
gboolean adms_preprocessor_pragma_define_has_noarg_and_text (p_preprocessor_pragma_define pragma)
{
  gboolean test;
  test = adms_preprocessor_pragma_define_has_noarg(pragma)
         &&
         adms_preprocessor_pragma_define_has_text(pragma)
         ;
  return test;
}
gboolean adms_preprocessor_pragma_define_has_nullarg_and_notext (p_preprocessor_pragma_define pragma)
{
  gboolean test;
  test = adms_preprocessor_pragma_define_has_nullarg(pragma)
         &&
         adms_preprocessor_pragma_define_has_notext(pragma)
         ;
  return test;
}
gboolean adms_preprocessor_pragma_define_has_nullarg_and_text (p_preprocessor_pragma_define pragma)
{
  gboolean test;
  test = adms_preprocessor_pragma_define_has_nullarg(pragma)
         &&
         adms_preprocessor_pragma_define_has_text(pragma)
         ;
  return test;
}
gboolean adms_preprocessor_pragma_define_has_arg_and_notext (p_preprocessor_pragma_define pragma)
{
  gboolean test;
  test = adms_preprocessor_pragma_define_has_arg(pragma)
         &&
         adms_preprocessor_pragma_define_has_notext(pragma)
         ;
  return test;
}
gboolean adms_preprocessor_pragma_define_has_arg_and_text (p_preprocessor_pragma_define pragma)
{
  gboolean test;
  test = adms_preprocessor_pragma_define_has_arg(pragma)
         &&
         adms_preprocessor_pragma_define_has_text(pragma)
         ;
  return test;
}
static gboolean adms_preprocessor_identifier_is_pragma_cb (p_preprocessor_pragma_define pragma, gchar * identifier)
{
  return (!!strcmp(pragma->name,identifier));
}
p_preprocessor_pragma_define adms_preprocessor_pragma_define_exists (gchar * name)
{
  GSList * Data;
  p_preprocessor_pragma_define pragma;
  if((Data = g_slist_find_custom ( adms_preprocessor_get_main()->Defined, name,
      (GCompareFunc) adms_preprocessor_identifier_is_pragma_cb)))
    pragma = (p_preprocessor_pragma_define) Data->data;
  else
    pragma = NULL;
  return pragma;
}
p_preprocessor_pragma_define adms_preprocessor_define_add (gchar * name)
{
  p_preprocessor_pragma_define pragma;
  if ((pragma = adms_preprocessor_pragma_define_exists(name)))
  {
    if( pragma->isDefined == TRUE )
      adms_message_warning("pragma redefined ... '%s'\n",name )
      pragma->hasArg = FALSE;
      pragma->arg = NULL;
      pragma->text = NULL;
  }
  else
  {
    pragma = g_new0(t_preprocessor_pragma_define,1 );
    pragma->name = name;
    qpush(&(adms_preprocessor_get_main()->Defined), pragma );
  }
  pragma->isDefined = TRUE;
  return pragma;
}
gboolean adms_preprocessor_define_add_default (gchar * name)
{
  p_preprocessor_pragma_define pragma;
  pragma = adms_preprocessor_define_add (name);
  adms_message_verbose ("defining macro ... '%s'\n",name)
  g_assert(adms_preprocessor_pragma_define_has_noarg_and_notext(pragma));
  return FALSE;
}
gboolean adms_preprocessor_define_add_default_with_text (gchar * name, gchar * value)
{
  GSList * Text;
  p_preprocessor_text text;
  p_preprocessor_pragma_define pragma;
  text = adms_preprocessor_new_text_as_string(value);
  Text = g_slist_prepend(NULL, text);
  pragma = adms_preprocessor_define_add_with_text (name, Text);
  adms_message_verbose ("defining macro with value ... '%s=%s'\n",name, value)
  g_assert(adms_preprocessor_pragma_define_has_noarg_and_text(pragma));
  return FALSE;
}
p_preprocessor_pragma_define adms_preprocessor_undefine_add (gchar * name)
{
  p_preprocessor_pragma_define pragma;
  pragma = adms_preprocessor_pragma_define_exists(name);
  if(!pragma)
    {
      pragma = g_new0(t_preprocessor_pragma_define,1 );
      pragma->name = name;
      qpush(&(adms_preprocessor_get_main()->Defined), pragma );
    }
  pragma->isDefined = FALSE;
  return pragma;
}
p_preprocessor_pragma_define adms_preprocessor_define_add_with_arg (gchar * name, GSList * arg)
{
  p_preprocessor_pragma_define pragma;
  pragma = adms_preprocessor_define_add (name );
  pragma->hasArg = TRUE;
  pragma->arg = arg;
  pragma->text = NULL;
  return pragma;
}
GFunc pragma_define_add_text_cb_cb ( gchar * arg, p_preprocessor_text text)
{
  gboolean stop = FALSE;
  if ((text->_isarg != -1) && !strcmp(text->_str,arg))
    {
      text->_isarg = TRUE;
      stop = TRUE;
    }
  return GINT_TO_POINTER(FALSE);
}
GFunc pragma_define_add_text_cb (p_preprocessor_text  text, p_preprocessor_pragma_define pragma)
{
  g_slist_foreach (pragma->arg, (GFunc) pragma_define_add_text_cb_cb, text);
  return GINT_TO_POINTER(FALSE);
}
p_preprocessor_pragma_define adms_preprocessor_define_add_with_text (gchar * name, GSList * text)
{
  p_preprocessor_pragma_define pragma;
  pragma = adms_preprocessor_define_add (name );
  pragma->hasArg = FALSE;
  pragma->arg = NULL;
  pragma->text = text;
  return pragma;
}
p_preprocessor_pragma_define adms_preprocessor_define_add_with_arg_and_text (gchar * name, GSList * arg, GSList * text)
{
  p_preprocessor_pragma_define pragma;
  pragma = adms_preprocessor_define_add_with_arg (name, arg );
  pragma->text = text;
  g_slist_foreach ( pragma->text, (GFunc) pragma_define_add_text_cb, pragma);
  return pragma;
}
static gboolean adms_preprocessor_get_line_position_cb (p_continuator continuator, gint char_pos)
{
  return ( char_pos > continuator->char_position );
}
static gboolean adms_preprocessor_get_char_position_cb (p_continuator continuator, gint char_pos)
{
  return ( char_pos < continuator->char_position );
}
gint adms_preprocessor_get_char_position (p_preprocessor cr_preprocessor)
{
  gint char_pos;
  char_pos = cr_preprocessor->cur_char_position - adms_preprocessor_leng;
  if( cr_preprocessor->cur_continuator_position )
    {
      GSList * Reversed;
      GSList * Data;
      Reversed = cr_preprocessor->cur_continuator_position;
      Data = g_slist_find_custom ( Reversed, (gpointer) char_pos,
      (GCompareFunc) adms_preprocessor_get_char_position_cb );
      if( Data)
        char_pos -= ((p_continuator) (Data->data))->char_position;
    }
  return char_pos;
}
gint adms_preprocessor_get_line_position (p_preprocessor cr_preprocessor, gint char_pos)
{
  gint line_pos;
  line_pos = cr_preprocessor->cur_line_position;
  if( cr_preprocessor->cur_continuator_position )
    {
      GSList * Reversed;
      GSList * Data;
      Reversed = g_slist_reverse(cr_preprocessor->cur_continuator_position );
      Data = g_slist_find_custom ( Reversed, (gpointer) char_pos,
        (GCompareFunc) adms_preprocessor_get_line_position_cb );
      if( Data)
        line_pos = ((p_continuator) (Data->data))->line_position;
      cr_preprocessor->cur_continuator_position = g_slist_reverse(Reversed );
    }
  return line_pos;
}
gint adms_preprocessor_get_line_position_with_error (p_preprocessor cr_preprocessor)
{
  gint lnumber;
  gint char_pos;
  char_pos = cr_preprocessor->cur_char_position - adms_preprocessor_leng;
  lnumber = adms_preprocessor_get_line_position(cr_preprocessor, char_pos );
  return lnumber;
}
