/*
 * RCS Info
 * $Id: admsXml.h,v 1.41 2006/03/15 17:39:30 r29173 Exp $
 * 
 * Log
 * $Log: admsXml.h,v $
 * Revision 1.41  2006/03/15 17:39:30  r29173
 * removed 'instanceofanalogfunction' element.
 * renamed attributes of admstvariable (svalue, evalue)
 * added support to global admst variables
 *
 * Revision 1.40  2005/11/25 14:15:25  r29173
 * changed admstpath parser mechanisms
 *
 * Revision 1.39  2005/11/18 10:08:07  r29173
 * simplified/renamed elements admst, production, productionitem
 *
 * Revision 1.38  2005/11/17 10:52:43  r29173
 * renamed arguments of adms_admstpath_evaluate
 *
 * Revision 1.37  2005/11/09 16:25:22  r29173
 * moved C code to xm code (calc of math/dependent)
 * renamed some functions
 * fixed memory violation (free)
 *
 * Revision 1.36  2005/11/07 17:42:11  r29173
 * renamed some functions - implemented '*' in admstpath
 *
 * Revision 1.35  2005/06/13 16:07:22  r29173
 * simplified admst parser
 *
 * Revision 1.34  2005/06/09 16:54:50  r29173
 * deleted xmlParserNew.c -- SLOWSLOW
 *
 * Revision 1.33  2005/06/02 13:26:40  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.32  2005/06/01 15:30:29  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.31  2005/05/25 08:27:50  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.30  2005/05/09 14:38:32  r29173
 * cleaned-up source directory structure
 *
 * Revision 1.29  2005/05/03 09:35:16  r29173
 * cleaned-up header file dependencies
 *
 * Revision 1.28  2005/05/03 07:58:21  r29173
 * moved admsNS into admsFile
 *
 * Revision 1.27  2005/05/02 16:02:00  r29173
 * fixed bug in memory allocation
 *
 * Revision 1.26  2005/05/02 07:09:24  r29173
 * improved memory usage
 *
 * Revision 1.25  2005/04/25 12:29:33  r29173
 * fixed few memory leak issues (introduced adms.._free)
 *
 * Revision 1.24  2005/03/31 18:12:02  r29173
 * migration to adms-2.x.x: converted to adms2 syntax
 *
 * Revision 1.23  2005/03/24 17:03:27  r29173
 * migration to adms-2.x.x: fixed bugs in admstpath parser
 *
 * Revision 1.22  2005/02/14 10:41:17  r29173
 * migration to adms-2.x.x: moved templates to Version.xml
 *
 * Revision 1.21  2005/02/14 08:44:39  r29173
 * release 1.47.0
 * migration to adms-2.x.x: converted contribution/assignment
 *
 * Revision 1.20  2005/01/28 09:08:55  r29173
 * migration to adms-2.x.x - started replacement of whileloop
 *
 * Revision 1.19  2005/01/24 13:19:26  r29173
 * migration to adms-2.x.x - fixed bugs in evaluate/adms:apply-templates
 *
 * Revision 1.18  2005/01/19 09:00:30  r29173
 * migration to adms-2.x.x - fixed bug in apply-templates and adms:if
 *
 * Revision 1.17  2005/01/17 09:28:01  r29173
 * migration to adms-2.x.x
 *
 * Revision 1.16  2004/11/23 17:19:27  r29173
 * moved code from xmlParser.c to admsImplicitTransforms.xml
 * started noise code handling
 *
 * Revision 1.15  2004/11/19 12:29:56  r29173
 * renamed _C into CAT
 * saved argc, argv into admsmain element
 * added adms:setenv transform
 *
 * Revision 1.14  2004/11/04 16:58:00  r29173
 * added admsImplicitTransforms.xml.h header file
 *
 * Revision 1.13  2004/11/02 08:58:42  r29173
 * default output to stdout in xml programs
 * added predicate:isdefault
 * moved code from xmlProgram.c to admsImplicitTransforms.xml
 *
 * Revision 1.12  2004/10/27 16:11:39  r29173
 * release 1.37.0
 * tons of changes - modify the way settors and gettors are built
 * from adms.xml in order to simplify admsProgram.c
 * added zspice to testbench
 * spectre/ads/mica/zspice/simkit passed
 *
 * Revision 1.11  2004/10/20 15:33:51  r29173
 * tons of changes
 * 1- introduced element whileloop (marat)
 * 2- reshaped the handling of the messaging system
 * 3- fixed bug in admsCheck/Makefile.am
 * 4- started implementation of implicit adms transforms
 *
 * Revision 1.10  2004/10/19 10:24:45  r29173
 * release 1.35.0
 * renamed 'adms rules' to adms:transform (adms namespace)
 * mica/ads/simkit passed
 * spectre failed: removed loadDynamic
 *
 * Revision 1.9  2004/10/18 13:35:39  r29173
 * changed prefix of adms 'transforms' from xsl: to adms:
 * renamed 'adms transforms' to 'adms transforms'
 * renamed adms transforms adms:defined and adms:undefined to adms:if
 * introduced SiMKiT to testbench
 * improved handling of property 'separator' in adms:join
 * spectre/mica/ads passed
 *
 * Revision 1.7  2004/10/14 10:05:32  r29173
 * fixed bug in setting of _pwd for open/defined/undefined transforms
 * renamed _pwd and _up to _dot and _dotdot
 * resolve transform symbol just after creating transform
 *
 * Revision 1.6  2004/10/12 08:33:48  r29173
 * introduced xsl:templates and xsl:apply-template transforms (NO COMPLETED)
 * implement xml 'set' transform
 *
 * Revision 1.5  2004/10/08 18:40:19  r29173
 * moved element 'simulator' from hard-coded to adms.xml
 *
 * Revision 1.4  2004/09/07 07:41:36  r29173
 * renamed some routines
 *
 * Revision 1.3  2004/08/03 12:33:55  r29173
 * import adms-1.21.0 from local CVS
 *
 * Revision 1.7  2004/08/03 09:23:10  r29173
 * renamed superelement into element
 *
 * Revision 1.6  2004/07/21 12:11:07  r29173
 * removed evaluation->_evalue - replaced by math->_evalue
 * release 1.19.0
 * SPevaluate.include fails: 0 is now treated as iszero like 0.0
 *
 * Revision 1.5  2004/07/07 07:31:23  r29173
 * moved definition of macro _C
 * GLib->xml transition: admsProgram.c done
 *
 * Revision 1.4  2004/07/06 19:17:57  r29173
 * started implementing yacc code for element "nature"
 * resumed transition GLib -> adms.xml
 *
 * Revision 1.3  2004/06/30 16:40:58  r29173
 * renamed all admsObject files to object<Filename>
 *
 * Revision 1.2  2004/05/26 13:02:47  r29173
 * added default values to all enumerations
 *
 * Revision 1.1.1.1  2004/05/21 12:20:01  r29173
 * recreated cvs data structure (crashed after revision 1.13.0!)
 *
 * Revision 1.25  2004/05/17 11:50:28  r29173
 * simplified handling of variable attributes
 *
 * Revision 1.24  2004/05/04 08:07:09  r29173
 * added code for @final
 * removed libltdl
 *
 * Revision 1.23  2004/04/22 09:49:14  r29173
 * moved xparser structure into xmlParser
 *
 * Revision 1.22  2004/04/21 14:25:34  r29173
 * simplified xparser->_current_stack
 *
 * Revision 1.21  2004/04/19 20:23:25  r29173
 * simplified macros in xmlNode.h
 *
 * Revision 1.20  2004/04/19 16:24:31  r29173
 * moved code of xparser to xmlParser
 *
 * Revision 1.19  2004/04/19 14:52:19  r29173
 * cleaned-up code
 * added handling of \t in xml files
 *
 * Revision 1.18  2004/03/25 20:14:49  r29173
 * splitted variable->scope into small pieces
 *
 * Revision 1.17  2004/03/23 13:44:29  r29173
 * fixed name spelling (lowercase to uppercase)
 *
 * Revision 1.16  2004/03/19 12:45:35  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.15  2004/03/08 13:58:07  r29173
 * all code lower-cased
 *
 * Revision 1.14  2004/03/08 08:24:20  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.13  2004/02/18 23:30:46  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.12  2004/02/10 16:44:30  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.11  2004/02/06 14:52:08  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.10  2004/01/21 14:35:46  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.9  2004/01/09 16:23:49  r29173
 * cleaned-up use of #include
 *
 * Revision 1.8  2004/01/06 14:13:13  r29173
 * fixed definition of win32_interface
 *
 * Revision 1.7  2003/12/11 16:10:11  r29173
 * changed usage of win32_interface
 *
 * Revision 1.6  2003/12/11 16:01:54  r29173
 * changed prefix [epst]_adms_ to [epst]_
 *
 * Revision 1.5  2003/07/22 14:46:06  r29173
 * simplified procedure to create admsObject
 *
 * Revision 1.4  2003/06/26 15:16:15  r29173
 * added feature /simulator/currentdate
 *
 * Revision 1.3  2003/06/23 06:59:53  r29173
 * added /simulator/fullname functionnality
 *
 * Revision 1.2  2003/05/21 14:18:02  r29173
 * add rcs info
 *
 */

#ifndef adms_xml_h
#define adms_xml_h

#include <admsFile/admsFile.h>
#include <admsObject/admsH.h>

#undef win32_interface
#if defined(WIN32)
#  if defined(_inside_admsXml)
#    define win32_interface __declspec(dllexport)
#  else
#    define win32_interface __declspec(dllimport)
#  endif
#else
#  define win32_interface extern
#endif

/*xmlXparser.c && admsXml.c*/
win32_interface void adms_xml_load_xml_admsttransform_from_file (const char *filename);

/*xmlXparser.c && admsXml.c*/
win32_interface int adms_preprocessor_and_parse_veriloga (const int argc,const char**argv);

/*xmlProgram.c && xmlXpath.c*/
win32_interface char *adms_admsstack_sprintf (p_admsttransform myadmsttransform,char *pvalue,int*isstring);
win32_interface p_production adms_admstpath_evaluate(p_admsttransform myadmsttransform,p_admst myadmstparent,const char *myadmstpath);

#endif /* adms_xml_h */
