/*
 * RCS Info
 * $Id: xmlParser.c,v 1.64 2006/03/24 16:13:24 r29173 Exp $
 *
 * Log
 * $Log: xmlParser.c,v $
 * Revision 1.64  2006/03/24 16:13:24  r29173
 * added block variables handler
 *
 * Revision 1.63  2006/02/21 11:27:20  r29173
 * added new element 'nilled'.
 *
 * Revision 1.62  2006/01/31 14:29:19  r29173
 * apply numerical evaluation to analog functions
 *
 * Revision 1.61  2006/01/26 08:23:27  r29173
 * added veriloga 'case' statement
 *
 * Revision 1.60  2005/12/07 09:35:42  r29173
 * moved XML code back to C code (AE block)
 *
 * Revision 1.59  2005/12/05 12:57:23  r29173
 * improved admst parser
 *
 * Revision 1.58  2005/12/04 09:36:31  sukharev
 * The  and  functions was added
 *
 * Revision 1.57  2005/12/02 17:48:42  r29173
 * cleaned-up admstpath lexical analyzer (lexan)
 *
 * Revision 1.56  2005/12/01 13:12:11  r29173
 * fixed bug in admst memory handling
 *
 * Revision 1.55  2005/11/30 13:59:16  r29173
 * added memory tracker on element admst
 *
 * Revision 1.54  2005/11/25 14:15:25  r29173
 * changed admstpath parser mechanisms
 *
 * Revision 1.53  2005/11/18 10:08:07  r29173
 * simplified/renamed elements admst, production, productionitem
 *
 * Revision 1.52  2005/11/17 10:53:33  r29173
 * added MACRO for getenv
 *
 * Revision 1.51  2005/11/16 16:01:02  r29173
 * added elements production and productionitem
 *
 * Revision 1.50  2005/11/14 14:22:29  r29173
 * creates .adms.implicit.xml all time
 *
 * Revision 1.49  2005/11/09 16:25:22  r29173
 * moved C code to xm code (calc of math/dependent)
 * renamed some functions
 * fixed memory violation (free)
 *
 * Revision 1.48  2005/06/21 14:38:44  r29173
 * add /simulator/function list
 *
 * Revision 1.47  2005/06/20 06:45:02  r29173
 * debug memory allocation with valgrind
 *
 * Revision 1.46  2005/06/17 16:44:16  r29173
 * debug memory allocation with valgrind
 *
 * Revision 1.45  2005/06/13 16:07:22  r29173
 * simplified admst parser
 *
 * Revision 1.44  2005/06/09 16:54:50  r29173
 * deleted xmlParserNew.c -- SLOWSLOW
 *
 * Revision 1.43  2005/05/27 16:30:39  r29173
 * moving code from xmlParserNew.c to xml - added subexpression
 *
 * Revision 1.42  2005/05/25 08:27:50  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.41  2005/05/19 17:08:29  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.40  2005/05/09 14:38:32  r29173
 * cleaned-up source directory structure
 *
 * Revision 1.39  2005/05/03 09:35:16  r29173
 * cleaned-up header file dependencies
 *
 * Revision 1.38  2005/05/03 07:58:21  r29173
 * moved admsNS into admsFile
 *
 * Revision 1.37  2005/04/29 16:02:34  r29173
 * improved memory usage
 *
 * Revision 1.36  2005/03/31 18:12:02  r29173
 * migration to adms-2.x.x: converted to adms2 syntax
 *
 * Revision 1.35  2005/03/07 10:17:17  r29173
 * migration to adms-2.x.x: fixed bug in admsattribute handling
 *
 * Revision 1.34  2005/03/04 18:09:41  r29173
 * migration to adms-2.x.x: added admsxml elements
 *
 * Revision 1.33  2005/02/26 09:53:15  r29173
 * migration to adms-2.x.x: added admst:new; applied to jacobian
 *
 * Revision 1.32  2005/02/22 20:09:07  r29173
 * migration to adms-2.x.x: renamed if:select to if:test
 *
 * Revision 1.31  2005/02/20 11:46:08  r29173
 * migration to adms-2.x.x: renamed device to module
 *
 * Revision 1.30  2005/02/20 11:00:57  r29173
 * migration to adms-2.x.x: renamed devicenode to node
 *
 * Revision 1.29  2005/02/18 16:34:22  r29173
 * migration to adms-2.x.x: changed syntax of admst:open
 *
 * Revision 1.28  2005/02/17 17:04:03  r29173
 * fixed some typos in admsXml -h
 *
 * Revision 1.27  2005/02/17 17:00:18  r29173
 * added missing "errno.h"; turned some warnings off; added more stuffs to vlatomml
 *
 * Revision 1.26  2005/02/17 08:22:34  r29173
 * migration to adms-2.x.x: fixed bug in preprocessor (line number tracking)
 *
 * Revision 1.25  2005/02/14 10:41:17  r29173
 * migration to adms-2.x.x: moved templates to Version.xml
 *
 * Revision 1.24  2005/02/14 08:44:39  r29173
 * release 1.47.0
 * migration to adms-2.x.x: converted contribution/assignment
 *
 * Revision 1.23  2005/01/31 17:44:19  r29173
 * migration to adms-2.x.x - moved code (contribution)
 *
 * Revision 1.22  2005/01/28 09:08:55  r29173
 * migration to adms-2.x.x - started replacement of whileloop
 *
 * Revision 1.21  2005/01/27 11:12:01  r29173
 * migration to adms-2.x.x - fixed namespace (admst)
 *
 * Revision 1.20  2005/01/25 10:15:43  r29173
 * migration to adms-2.x.x - cleaned-up code
 *
 * Revision 1.19  2005/01/17 09:28:01  r29173
 * migration to adms-2.x.x
 *
 * Revision 1.18  2005/01/11 09:57:58  r29173
 * tons of changes - simplify accessor names (valueof, valueto)
 *
 * Revision 1.17  2005/01/07 09:05:17  r29173
 * tons of changes - simplified adms.xml
 *
 * Revision 1.16  2005/01/06 09:39:46  r29173
 * tons of changes - metaadms.dtd validates adms.xml
 *
 * Revision 1.15  2004/11/19 12:29:56  r29173
 * renamed _C into CAT
 * saved argc, argv into admsmain element
 * added adms:setenv transform
 *
 * Revision 1.14  2004/11/10 13:51:45  r29173
 * release 1.39.0
 * tons of changes - moved code to xmlParser.c to admsImplicitTranform.xml
 * ads/mica/zspice/simkit passed except sgp.c (minor bug in previous version)
 * spectre failed (new xml interface - file spectreMODULE.c.xml)
 *
 * Revision 1.13  2004/11/02 08:58:42  r29173
 * default output to stdout in xml programs
 * added predicate:isdefault
 * moved code from xmlProgram.c to admsImplicitTransforms.xml
 *
 * Revision 1.12  2004/11/01 09:37:38  r29173
 * changed messaging macros (avoid useless computation of arguments)
 * improved the coding of transforms in xmlProgram.c
 *
 * Revision 1.11  2004/10/27 16:11:39  r29173
 * release 1.37.0
 * tons of changes - modify the way settors and gettors are built
 * from adms.xml in order to simplify admsProgram.c
 * added zspice to testbench
 * spectre/ads/mica/zspice/simkit passed
 *
 * Revision 1.10  2004/10/22 17:16:08  marat_yakupov
 * Fixed issue to allow compilation and prevent core dumps
 *
 * Revision 1.9  2004/10/21 09:05:11  r29173
 * added comments how to use adms shell variables (run admsXml with no args)
 *
 * Revision 1.8  2004/10/20 15:33:51  r29173
 * tons of changes
 * 1- introduced element whileloop (marat)
 * 2- reshaped the handling of the messaging system
 * 3- fixed bug in admsCheck/Makefile.am
 * 4- started implementation of implicit adms transforms
 *
 * Revision 1.7  2004/10/13 15:24:15  r29173
 * preprocess xml files passed to admsXml with adms_file_getpathname
 *
 * Revision 1.6  2004/10/08 18:40:19  r29173
 * moved element 'simulator' from hard-coded to adms.xml
 *
 * Revision 1.5  2004/10/01 08:49:20  r29173
 * moved load*_code from xmlParser.c to xmlProgram.c
 * removed quarks rule->_valid from xmlProgram.c
 *
 * Revision 1.4  2004/09/07 07:40:18  r29173
 * renamed some routines
 *
 * Revision 1.3  2004/08/19 16:46:44  r29173
 * cleaned-up i/o file handling
 *
 * Revision 1.2  2004/08/16 10:52:30  r29173
 * changed handling of adms_message_verbose (created adms_message_debug)
 *
 * Revision 1.1  2004/08/03 12:33:55  r29173
 * import adms-1.21.0 from local CVS
 *
 * Revision 1.32  2004/07/25 10:31:40  r29173
 * removed rule evaluation->_nolocal
 * propagated changes
 *
 * Revision 1.31  2004/07/22 14:17:05  r29173
 * simplified how evaluation->_value is built (improve direct access)
 * renamed math->_evalue to math->_value
 *
 * Revision 1.30  2004/07/21 12:11:07  r29173
 * removed evaluation->_evalue - replaced by math->_evalue
 * release 1.19.0
 * SPevaluate.include fails: 0 is now treated as iszero like 0.0
 *
 * Revision 1.29  2004/07/16 13:25:04  r29173
 * clean-up code
 * added check for probe->discipline
 *
 * Revision 1.28  2004/07/16 09:37:13  r29173
 * removed branch->name, jacobian->name and source->name
 *
 * Revision 1.27  2004/07/15 20:26:32  r29173
 * created element analog and attribute device->analog
 * device->analog contains the data tree of the analog section in verilog-ams
 * NOTE:
 * vs differs for spectre/ads/mica. The jacobians are listed in reversed order.
 * This change in behavior has been accepted.
 *
 * Revision 1.26  2004/07/14 15:41:20  r29173
 * removed code used to handle GLib tree data structure
 * modify xmlParserNew.c so that only one evaluation is used by
 * tostring in non-expressions
 *
 * Revision 1.25  2004/07/09 16:25:34  r29173
 * GLib->xml transition:
 *   moved attributes treedata->dynamic/flickernoise/whitenoise
 *   to contribution
 *
 * Revision 1.24  2004/07/09 14:39:11  r29173
 * removed data structure ns
 *
 * Revision 1.23  2004/07/08 21:31:41  r29173
 * GLib->xml transition: resumed removing xparser
 *
 * Revision 1.22  2004/07/08 15:34:05  r29173
 * GLib->xml transition
 * 1- started removing xparser data structure
 * 2- removed n_list
 *
 * Revision 1.21  2004/07/08 14:34:42  r29173
 * GLib->xml transition: removed n_rootexpression
 *
 * Revision 1.20  2004/07/08 14:19:19  r29173
 * GLib->xml transition
 * 1- added elements block and callfunction
 * 2- started transition of contribution, callfunction, block, assignment, conditional
 *
 * Revision 1.19  2004/07/07 21:48:36  r29173
 * GLib->xml transition: removed GLib tree under n_rootexpression
 *
 * Revision 1.18  2004/07/07 16:14:41  r29173
 * added attribute evaluation->evalue + code
 *
 * Revision 1.17  2004/07/07 15:35:15  r29173
 * GLib->xml transition: local declaration of conditional fixed
 *
 * Revision 1.16  2004/07/07 08:31:34  r29173
 * GLib->xml transition: local declaration of conditional done
 *
 * Revision 1.15  2004/07/07 07:31:23  r29173
 * moved definition of macro _C
 * GLib->xml transition: admsProgram.c done
 *
 * Revision 1.14  2004/07/07 06:07:59  r29173
 * GLib->xml transition: replaced calculation of partial derivatives
 *
 * Revision 1.13  2004/07/06 19:17:57  r29173
 * started implementing yacc code for element "nature"
 * resumed transition GLib -> adms.xml
 *
 * Revision 1.12  2004/07/05 13:49:23  r29173
 * implementing code that will replace the GNode data tree in xmlParser
 *
 * Revision 1.11  2004/07/02 20:56:11  r29173
 * added element function
 * propagated the change to yacc and xmlParser
 *
 * Revision 1.10  2004/06/30 16:40:58  r29173
 * renamed all admsObject files to object<Filename>
 *
 * Revision 1.9  2004/06/30 10:08:03  r29173
 * fixed handling of gExpression
 * added element number in adms.xml
 *
 * Revision 1.8  2004/06/28 19:57:01  r29173
 * removed node n_branch_probe
 *
 * Revision 1.7  2004/06/28 19:28:42  r29173
 * removed n_branch_source
 *
 * Revision 1.6  2004/06/24 07:42:36  r29173
 * added $stop to verilog-ams
 * improved error message handling
 *
 * Revision 1.5  2004/05/27 15:27:14  r29173
 * added new element uid to adms.xml (replaced scalar)
 *
 * Revision 1.4  2004/05/26 15:06:16  r29173
 * removed treedata->static
 *
 * Revision 1.3  2004/05/26 13:57:13  r29173
 * replaced variable->sourcescope by variable->staticscope/variable->dynamicscope
 *
 * Revision 1.2  2004/05/26 13:02:47  r29173
 * added default values to all enumerations
 *
 * Revision 1.1.1.1  2004/05/21 12:20:01  r29173
 * recreated cvs data structure (crashed after revision 1.13.0!)
 *
 * Revision 1.67  2004/05/17 12:49:32  r29173
 * simplified handling of variable attributes
 *
 * Revision 1.66  2004/05/17 11:50:28  r29173
 * simplified handling of variable attributes
 *
 * Revision 1.65  2004/05/17 09:13:00  r29173
 * simplified handling of variable attributes
 *
 * Revision 1.64  2004/05/15 10:18:02  r29173
 * simplified handling of variable attributes
 *
 * Revision 1.63  2004/05/15 10:00:08  r29173
 * simplified handling of variable attributes
 *
 * Revision 1.62  2004/05/14 14:21:53  r29173
 * started removing usage of _cmp outside admsObject
 *
 * Revision 1.61  2004/05/13 07:34:50  r29173
 * continue removing GNode* structure
 *
 * Revision 1.60  2004/05/07 20:45:17  r29173
 * continue removing GNode* structure
 *
 * Revision 1.59  2004/05/07 19:55:55  r29173
 * continue removing GNode* structure
 *
 * Revision 1.58  2004/05/07 16:34:23  r29173
 * started removing GNode* structure
 *
 * Revision 1.57  2004/05/07 15:54:22  r29173
 * started removing GNode* structure
 *
 * Revision 1.56  2004/05/06 13:08:16  r29173
 * started removing GNode* structure
 *
 * Revision 1.55  2004/05/06 12:17:19  r29173
 * started removing GNode* structure
 *
 * Revision 1.54  2004/05/05 14:36:56  r29173
 * started removing GNode* structure
 *
 * Revision 1.53  2004/05/05 10:19:30  r29173
 * started removing GNode* structure
 *
 * Revision 1.52  2004/05/04 08:07:09  r29173
 * added code for @final
 * removed libltdl
 *
 * Revision 1.51  2004/04/22 09:49:13  r29173
 * moved xparser structure into xmlParser
 *
 * Revision 1.50  2004/04/21 14:25:34  r29173
 * simplified xparser->_current_stack
 *
 * Revision 1.49  2004/04/19 21:03:22  r29173
 * removed subdir admsTree
 *
 * Revision 1.48  2004/04/19 20:23:25  r29173
 * simplified macros in xmlNode.h
 *
 * Revision 1.47  2004/04/19 16:24:31  r29173
 * moved code of xparser to xmlParser
 *
 * Revision 1.46  2004/04/19 15:41:37  r29173
 * moved code of treeValidate to xmlParser
 *
 * Revision 1.45  2004/04/19 14:52:19  r29173
 * cleaned-up code
 * added handling of \t in xml files
 *
 * Revision 1.44  2004/04/13 15:09:46  r29173
 * some code clean-up
 *
 * Revision 1.43  2004/04/01 15:46:25  r29173
 * fixed bug (tracking of fct(V(...))
 *
 * Revision 1.42  2004/04/01 15:06:39  r29173
 * added #ifdef NEWCALC to maintain old computation of VAL, DVAL
 *
 * Revision 1.41  2004/04/01 10:05:36  r29173
 * simplified code at nodes n_binary (multtime and multdiv)
 *
 * Revision 1.40  2004/03/31 16:04:30  r29173
 * simplified code at nodes n_binary (addp and addm)
 *
 * Revision 1.39  2004/03/31 13:43:28  r29173
 * release 1.10.0
 * code differs (comments) for rules device->load_code,
 * device->loadmodel_code, device->loadinstance_code
 * Changes SP-0.0.32 vla code:
 * $message, $warning and $error replaced by $strobe
 * SPinstloadInit.c differs
 *
 * Revision 1.38  2004/03/30 20:36:23  r29173
 * moved code that sets rules source->[static|dynamic]
 *
 * Revision 1.37  2004/03/30 15:38:37  r29173
 * moved code that sets rules branch->[static|dynamic]
 *
 * Revision 1.36  2004/03/30 15:17:17  r29173
 * removed treedata->derivate
 * renamed variable->has_derivate to variable->derivate
 *
 * Revision 1.35  2004/03/30 14:09:42  r29173
 * simplified coding style
 *
 * Revision 1.34  2004/03/30 13:15:34  r29173
 * simplified coding style
 *
 * Revision 1.33  2004/03/30 12:48:04  r29173
 * simplified coding style
 *
 * Revision 1.32  2004/03/30 09:06:34  r29173
 * added adms_message
 * added statistics
 * started noise implementation
 *
 * Revision 1.31  2004/03/27 17:20:51  r29173
 * fixed bad variable usage: variables both used in
 * @model/@evaluate
 * @instance/@evaluate
 *
 * Revision 1.30  2004/03/26 08:49:01  r29173
 * splitted variable->scope into small pieces
 *
 * Revision 1.29  2004/03/25 22:43:44  r29173
 * splitted variable->scope into small pieces
 *
 * Revision 1.28  2004/03/25 22:16:36  r29173
 * splitted variable->scope into small pieces
 *
 * Revision 1.27  2004/03/25 20:44:02  r29173
 * splitted variable->scope into small pieces
 *
 * Revision 1.25  2004/03/24 11:17:32  r29173
 * made code simplifications
 *
 * Revision 1.24  2004/03/24 10:56:24  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.23  2004/03/24 10:31:26  r29173
 * renamed n_procedural_assignment to n_assignment
 *
 * Revision 1.22  2004/03/23 21:20:52  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.21  2004/03/23 14:31:34  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.20  2004/03/23 13:44:29  r29173
 * fixed name spelling (lowercase to uppercase)
 *
 * Revision 1.19  2004/03/23 13:05:21  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.18  2004/03/22 08:46:03  r29173
 * release 1.7.5
 * Added protection against bad use of ddt operator
 *
 * Revision 1.17  2004/03/21 21:19:55  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.16  2004/03/21 10:36:58  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.15  2004/03/20 18:14:38  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.14  2004/03/19 17:20:14  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.13  2004/03/19 14:57:43  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.12  2004/03/19 12:45:35  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.11  2004/03/19 10:50:09  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.10  2004/03/19 10:24:59  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.9  2004/03/19 09:56:51  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.8  2004/03/18 16:06:14  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.7  2004/03/18 15:37:44  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.6  2004/03/18 12:36:44  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.5  2004/03/18 11:54:47  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.4  2004/03/18 11:30:00  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.3  2004/03/15 08:35:12  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.2  2004/03/10 15:50:05  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.1  2004/03/09 17:42:29  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.54  2004/03/04 11:01:28  r29173
 * started implementing code builder in yacc parser
 *
 */
#include <admsXml/admsXml.h>
#include <admsPreprocessor/admsPreprocessor.h>
#include <admsXml/admsImplicitTransforms.xml.c>
#include <admsObject/admsC.h>

_t_file_usage_static (adms_xml_usage)
{
  adms_message_usage ("%s source -e script1 [-e script2 ...]\n",g_get_prgname())
  adms_message_usage ("source: verilog-ams source code\n")
  adms_message_usage ("script1, ...: xml scripts\n")
}
#define DATATYPENAME adms_adms_valueof_datatypename(myany)
#define ADMS_NAN (0.0/0.0)
#define VALto(v) (adms_math_valueof_value(myany)->_real=v)
#define VALof(any) (adms_math_valueof_value(any)->_real)
p_expression MYEXPRESSION=NULL;
static void adms_xml_tonumeric(gpointer myany)
{
  if(DATATYPENAME==adms_adms_enumeration_datatypename_mapply_unary)
  {
    double x1;
    adms_xml_tonumeric(adms_mapply_unary_valueof_arg1(adms_mapply_unary(myany)));
    x1=VALof(adms_mapply_unary_valueof_arg1(adms_mapply_unary(myany)));
    e_mapply_unary_name e=adms_mapply_unary_valueof_name(adms_mapply_unary(myany));
    if(!isnan(x1))
    {
      switch(e)
      {
        case adms_mapply_unary_enumeration_name_plus:      VALto(x1);      break;
        case adms_mapply_unary_enumeration_name_minus:     VALto(-1.0*x1); break;
        case adms_mapply_unary_enumeration_name_not:       VALto(!x1);     break;
        default:
          adms_message_fatal("during evaluation - unary operator not implemented\n")
      }
    }
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_mapply_binary)
  {
    double x1;
    double x2;
    e_mapply_binary_name e=adms_mapply_binary_valueof_name(adms_mapply_binary(myany));
    adms_xml_tonumeric(adms_mapply_binary_valueof_arg1(adms_mapply_binary(myany)));
    adms_xml_tonumeric(adms_mapply_binary_valueof_arg2(adms_mapply_binary(myany)));
    x1=VALof(adms_mapply_binary_valueof_arg1(adms_mapply_binary(myany)));
    x2=VALof(adms_mapply_binary_valueof_arg2(adms_mapply_binary(myany)));
    switch(e)
    {
      case adms_mapply_binary_enumeration_name_addp:     VALto(x1+x2);  break;
      case adms_mapply_binary_enumeration_name_addm:     VALto(x1-x2);  break;
      case adms_mapply_binary_enumeration_name_multtime: VALto(x1*x2);  break;
      case adms_mapply_binary_enumeration_name_multdiv:  VALto(x1/x2);  break;
    }
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_mapply_ternary)
  {
    double x1,x2,x3;
    e_mapply_ternary_name e=adms_mapply_ternary_valueof_name(adms_mapply_ternary(myany));
    adms_xml_tonumeric(adms_mapply_ternary_valueof_arg1(adms_mapply_ternary(myany)));
    adms_xml_tonumeric(adms_mapply_ternary_valueof_arg2(adms_mapply_ternary(myany)));
    adms_xml_tonumeric(adms_mapply_ternary_valueof_arg3(adms_mapply_ternary(myany)));
    x1=VALof(adms_mapply_ternary_valueof_arg1(adms_mapply_ternary(myany)));
    x2=VALof(adms_mapply_ternary_valueof_arg2(adms_mapply_ternary(myany)));
    x3=VALof(adms_mapply_ternary_valueof_arg3(adms_mapply_ternary(myany)));
/*
    switch(e)
    {
      case adms_mapply_ternary_enumeration_name_conditional:
        if(x1==0.0)
          VALto(x3);
        else if(!isnan(x1))
          VALto(x2);
        break;
      default:
        adms_message_fatal("during string conversion - ternary operator not implemented\n")
    }
*/
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_variable)
  {}
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_number)
  {
    e_number_scalingunit unit=adms_number_valueof_scalingunit(myany);
    char*value=adms_number_valueof_value(myany);
    double evalue;
    errno=0;
    evalue=strtod(value,NULL);
    if(errno)
      adms_message_fatal("%s: numerical value was expected\n",value)
    if(0) {}
    else if(unit==adms_number_enumeration_scalingunit_1) VALto(evalue);
    else if(unit==adms_number_enumeration_scalingunit_E) VALto(evalue*1.0e+18);
    else if(unit==adms_number_enumeration_scalingunit_P) VALto(evalue*1.0e+15);
    else if(unit==adms_number_enumeration_scalingunit_T) VALto(evalue*1.0e+12);
    else if(unit==adms_number_enumeration_scalingunit_G) VALto(evalue*1.0e+9);
    else if(unit==adms_number_enumeration_scalingunit_M) VALto(evalue*1.0e+6);
    else if(unit==adms_number_enumeration_scalingunit_k) VALto(evalue*1.0e+3);
    else if(unit==adms_number_enumeration_scalingunit_h) VALto(evalue*1.0e+2);
    else if(unit==adms_number_enumeration_scalingunit_D) VALto(evalue*1.0e+1);
    else if(unit==adms_number_enumeration_scalingunit_d) VALto(evalue*1.0e-1);
    else if(unit==adms_number_enumeration_scalingunit_c) VALto(evalue*1.0e-2);
    else if(unit==adms_number_enumeration_scalingunit_m) VALto(evalue*1.0e-3);
    else if(unit==adms_number_enumeration_scalingunit_u) VALto(evalue*1.0e-6);
    else if(unit==adms_number_enumeration_scalingunit_n) VALto(evalue*1.0e-9);
    else if(unit==adms_number_enumeration_scalingunit_A) VALto(evalue*1.0e-10);
    else if(unit==adms_number_enumeration_scalingunit_p) VALto(evalue*1.0e-12);
    else if(unit==adms_number_enumeration_scalingunit_f) VALto(evalue*1.0e-15);
    else if(unit==adms_number_enumeration_scalingunit_a) VALto(evalue*1.0e-18);
    else
      adms_message_fatal("[%-15s].... '%s' unit maformed\n",__FUNCTION__,unit)
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_string)
  {}
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_function)
  {
    char*fname=adms_function_valueof_name(myany);
    g_slist_foreach(adms_function_valueof_arguments(myany),(GFunc)adms_xml_tonumeric,NULL);
    if(MYEXPRESSION)
      if(!strcmp(fname,"abs")|| !strcmp(fname,"$shrinkl")|| !strcmp(fname,"$shrinka")|| !strcmp(fname,"log")||
      !strcmp(fname,"ln")|| !strcmp(fname,"limexp")|| !strcmp(fname,"$limexp")||
      !strcmp(fname,"simparam")|| !strcmp(fname,"$simparam")||
      !strcmp(fname,"analysis")|| !strcmp(fname,"$analysis")||
      !strcmp(fname,"acos")|| !strcmp(fname,"asin")|| !strcmp(fname,"atan")|| !strcmp(fname,"cos")||
      !strcmp(fname,"cosh")|| !strcmp(fname,"exp")|| !strcmp(fname,"sin")|| !strcmp(fname,"sinh")||
      !strcmp(fname,"sqrt")|| !strcmp(fname,"tan")|| !strcmp(fname,"tanh")||
      !strcmp(fname,"pow")|| !strcmp(fname,"hypot")|| !strcmp(fname,"min")|| !strcmp(fname,"max"))
      adms_expression_list_function_prepend(MYEXPRESSION,myany);
    if(!strcmp(fname,"limexp")||!strcmp(fname,"$limexp"))
    {
      p_simulator mysimulator=adms_admsmain_valueof_simulator(adms_get_admsmain ());
      adms_simulator_list_function_prepend(mysimulator,myany);
    }
    adms_subexpression_valueto_expression(myany,MYEXPRESSION);
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_probe)
  {}
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_assignment)
  {
    adms_xml_tonumeric(adms_assignment_valueof_lhs(myany));
    adms_xml_tonumeric(adms_assignment_valueof_rhs(myany));
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_contribution)
  {
    adms_xml_tonumeric(adms_contribution_valueof_rhs(myany));
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_conditional)
  {
    adms_xml_tonumeric(adms_conditional_valueof_then(myany));
    if(adms_conditional_valueof_else(myany))
      adms_xml_tonumeric(adms_conditional_valueof_else(myany));
    adms_xml_tonumeric(adms_conditional_valueof_if(myany));
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_whileloop)
  {
    adms_xml_tonumeric(adms_whileloop_valueof_whileblock(myany));
    adms_xml_tonumeric(adms_whileloop_valueof_while(myany));
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_case)
  {
    adms_xml_tonumeric(adms_case_valueof_case(myany));
    g_slist_foreach(adms_case_valueof_caseitem(myany),(GFunc)adms_xml_tonumeric,NULL);
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_caseitem)
  {
    adms_xml_tonumeric(adms_caseitem_valueof_code(myany));
    g_slist_foreach(adms_caseitem_valueof_condition(myany),(GFunc)adms_xml_tonumeric,NULL);
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_expression)
  {
    MYEXPRESSION=myany;
    adms_xml_tonumeric(adms_expression_valueof_tree(myany));
    adms_expression_valueof_function(MYEXPRESSION)=g_slist_reverse(adms_expression_valueof_function(MYEXPRESSION));
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_blockvariable)
  {
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_callfunction)
  {
    g_slist_foreach(adms_function_valueof_arguments(
     adms_function(adms_callfunction_valueof_function(myany))),(GFunc)adms_xml_tonumeric,NULL);
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_nilled)
  {
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_block)
  {
    g_slist_foreach(adms_block_valueof_item(myany),(GFunc)adms_xml_tonumeric,NULL);
  }
  else if(DATATYPENAME==adms_adms_enumeration_datatypename_node)
  {
    adms_message_error("node not expected here ... '%s'\n",adms_node_getuid(myany))
    adms_message_fatal("May-be some discipline declarations are missing\n")
  }
  else
    adms_message_fatal("[%-15s].... '%i' element unexpected\n",__FUNCTION__,DATATYPENAME)
}

static void parameter_default_cb (p_variable myvariable)
{
  if(adms_variable_valueof_default(myvariable))
    adms_xml_tonumeric(adms_variable_valueof_default(myvariable));
}
/*
  <admst:for-each select="ae">
    <admst:if test="adms/[datatypename='expression']">
      <admst:for-each select="variable">
        <admst:value-to select="seen" value="yes"/>
      </admst:for-each>
      <admst:for-each select="variable">
        <admst:for-each select="variable[seen='no']">
          <admst:push into="../../variable" select="."/>
          <admst:value-to select="seen" value="yes"/>
        </admst:for-each>
      </admst:for-each>
      <admst:for-each select="variable">
        <admst:value-to select="seen" value="no"/>
      </admst:for-each>
    </admst:if>
    <!-- add lhs to assignment/variable and add all rhs/variable to lhs/variable -->
    <admst:if test="adms[datatypename='assignment']">
      <admst:for-each select="lhs/variable">
        <admst:value-to select="seen" value="yes"/>
      </admst:for-each>
      <admst:for-each select="rhs/variable[seen='no']">
        <admst:push into="../../lhs/variable" select="."/>
      </admst:for-each>
      <admst:for-each select="lhs/variable">
        <admst:value-to select="seen" value="no"/>
      </admst:for-each>
    </admst:if>
  </admst:if>
*/

static void adms_xml_init_beforexml_cb (p_module mymodule)
{

  GSList*l;
  adms_message_verbose("apply transforms before xml files\n")
  if(adms_module_valueof_analog(mymodule))
  {
    adms_module_valueto_evaluation(mymodule,adms_evaluation_new(mymodule));
    adms_xml_tonumeric(adms_analog_valueof_code(adms_module_valueof_analog(mymodule)));
  }
  for(l=adms_module_valueof_analogfunction(mymodule);l;l=l->next)
  {
    p_analogfunction myanalogfunction=adms_analogfunction(l->data);
    adms_xml_tonumeric(adms_analogfunction_valueof_tree(myanalogfunction));
  }
  g_slist_foreach(adms_module_valueof_variable(mymodule),(GFunc)parameter_default_cb,NULL);
}
static char* adms_parse_create_admsimplicitxmlfile (void)
{
  GError *error=NULL;
  char *mygetenv = getenv("adms_implicit_transforms");
  char *tmpFileName=NULL;
  if (mygetenv)
  {
    tmpFileName = adms_file_getpathname (mygetenv);
    adms_message_info ("loading local transforms %s\n",tmpFileName)
  }
  else
  {
    char* curdir = g_get_current_dir ();
    tmpFileName = g_build_filename (curdir,".adms.implicit.xml",NULL);
    adms_message_verbose ("creating/loading implicit transforms file %s\n",tmpFileName)
    adms_file_setfile_output(adms_file_open_write (tmpFileName,__FUNCTION__));
    g_print("%s",admsImplicitTransforms_xml);
    adms_file_close_output ();
  }
  return tmpFileName;
}
static int adms_parse_veriloga_cb (const char* myfilename,FILE * ifh)
{
  GTimer *mytimer=g_timer_new ();
  adms_veriloga_setfile_input (ifh);
  if (!adms_veriloga_parse (adms_get_admsmain ()))
    adms_message_verbose ("No error found during parsing\n")
  else
    adms_message_fatal ("parsing failed\n")
  adms_message_verbose ("[veriloga-parsing] elapsed time: %g\n",g_timer_elapsed (mytimer,NULL))
  g_timer_reset (mytimer);
  adms_file_setfile_output(stdout);
  {
    char *tmpFileName=adms_parse_create_admsimplicitxmlfile ();
    g_slist_foreach(adms_admsmain_valueof_module(adms_get_admsmain()),(GFunc)adms_xml_init_beforexml_cb,NULL);
    adms_xml_load_xml_admsttransform_from_file (tmpFileName);
    g_free(tmpFileName);
  }
  adms_message_verbose ("[xml-init] elapsed time: %g\n",g_timer_elapsed (mytimer,NULL))
  g_timer_reset (mytimer);
  adms_message_verbose ("No error found during xml script processing\n")
  g_timer_destroy (mytimer);
  return FALSE;
}
static void adms_parse_veriloga (const char* filename,const int argc,const char* *argv)
{
  FILE *ifh = adms_file_open_read(filename,__FUNCTION__);
  if (getenv("adms_veriloga_debug"))
    adms_veriloga_setint_yydebug(1);
  if (ifh)
    adms_parse_veriloga_cb (filename,ifh);
  else
   adms_message_fatal ("can not open temporary file %s\n",filename)
}
const int admspreprocessor_init (const char* mytmpFileName,FILE *ifh)
{
  FILE *ofh;
  GError *error=NULL;
  adms_preprocessor_setfile_input (ifh);
  ofh = adms_file_open_write (mytmpFileName,"create-temporary-file");
  adms_file_setfile_output(ofh);
  adms_message_verbose ("creating temporary file %s\n",mytmpFileName)
  if (!error)
  {
    gboolean parse_error;
    parse_error = adms_preprocessor_parse();
    return 0;
  }
  else
    adms_message_fatal ("%s\n",error->message)
  fclose (ofh);
}
_t_file_usage_static (adms_preprocessor_usage)
{
  adms_message_usage ("%s source [options] -e script1 [-e script2 ...]\n",g_get_prgname())
  adms_message_usage ("files:\n")
  adms_message_usage ("  source: verilog-ams source code\n")
  adms_message_usage ("  script1, ...: admst scripts (xml format)\n")
  adms_message_usage ("options:\n")
  adms_message_usage ("  -D NAME: predefine NAME as a macro, with definition `1'\n")
  adms_message_usage ("  -D NAME=DEFINITION: predefine NAME as a macro, with definition DEFINITION\n")
  adms_message_usage ("  -I DIR: Add directory DIR to search path for header files\n")
  adms_message_usage ("shell variables:\n")
  adms_message_usage ("- adms_info=\"no\": do not print info [default is yes]\n")
  adms_message_usage ("- adms_usage=\"no\": do not print usage [default is yes]\n")
  adms_message_usage ("- adms_verbose=\"yes\": print messages [default is no]\n")
  adms_message_usage ("- adms_debug=\"yes\": print more messages [default is no]\n")
  adms_message_usage ("- adms_implicit_transforms=<script>: includes admst script <script> prior any -e admst files\n")
  adms_message_usage ("  Otherwise admst script .adms.implicit.xml is included and saved in local directory\n")
}
static int adms_xml_program_read_xml_program (const char*filename)
{
#define admstfileList adms_admsmain_valueof_admstfile(adms_get_admsmain())
  GError *error=NULL;
  adms_message_debug("%s: read xml script %s\n",(char*)admstfileList?admstfileList->data:g_strdup(""),filename)
  adms_file_setfile_output(stdout);
  adms_xml_load_xml_admsttransform_from_file (filename);
  /*g_slist_free(Templates);
  Templates=NULL;*/
  return 0;
}
static int adms_evaluate_xmlscripts (const int argc,const char* *argv)
{
  GTimer *mytimer=g_timer_new ();
  GSList *scripts_from_argv = adms_file_get_program_from_argv(argc,argv);
  if(scripts_from_argv)
    g_slist_foreach (scripts_from_argv,(GFunc) adms_xml_program_read_xml_program,NULL);
  else
    adms_file_print_usage (adms_preprocessor_usage);
  adms_message_verbose ("[xml-evaluate] elapsed time: %g\n",g_timer_elapsed (mytimer,NULL))
}
int adms_preprocessor_and_parse_veriloga (const int argc,const char**argv)
{
  GTimer *mytimer = g_timer_new ();
  gdouble ParserELapsedTime=0.0;
  gdouble BuilderELapsedTime=0.0;
  gdouble XmlELapsedTime=0.0;
  char*loc=NULL;
  char*myprgname=g_strdup_printf("%sXml",PACKAGE_NAME);
  p_simulator mysimulator;
  g_set_prgname(myprgname);
  g_set_print_handler ((GPrintFunc) adms_file_filehandling_print);
  free(myprgname);
  adms_valueto_admsmain (argc,argv);
  {
    char*fullname;
    if(getenv("adms_check"))
      fullname=g_strdup_printf ("%s-0.0.0 (shell variable 'adms_check' is set!)", g_get_prgname());
    else
      fullname=g_strdup_printf("%s-%s", g_get_prgname(), PACKAGE_VERSION);
    mysimulator=adms_simulator_new(fullname);
    adms_simulator_valueto_fullname(mysimulator,fullname);
  }
  {
    char*developer;
    if(getenv("adms_check"))
      developer=g_strdup ("0.0.0 (shell variable 'adms_check' is set)");
    else
      developer=g_strdup_printf("%s-%s (%s-%s)",g_get_prgname(), PACKAGE_VERSION, __DATE__,__TIME__);
    adms_simulator_valueto_developer(mysimulator,developer);
  }
  {
    char *current_date;
    if(getenv("adms_check"))
      current_date=g_strdup ("0.0.0 (shell variable 'adms_check' is set)\n");
    else
    {
      char current_date_buffer[101];
      GDate* d = g_date_new();
      g_date_set_time(d, time(NULL));
      g_date_strftime(current_date_buffer,100,"%A, %x\n", d);
      current_date=g_strdup_printf ("%s",current_date_buffer);
    }
    adms_simulator_valueto_currentdate(mysimulator,current_date);
  }
  adms_admsmain_valueto_simulator(adms_get_admsmain (),mysimulator);

  g_log_set_always_fatal (G_LOG_LEVEL_CRITICAL);
  if (getenv("adms_preprocessor_debug"))
    adms_preprocessor_setint_yydebug(1);
  else
    adms_preprocessor_setint_yydebug(0);
#define TESTGETENV(name,value) \
if(getenv("adms_"#name)&&!strcmp(getenv("adms_"#name),#value)) \
  adms_admsmain_valueto_##name(adms_get_admsmain(),adms_admsmain_enumeration_##name##_##value);
  TESTGETENV(info,no)
  TESTGETENV(usage,no)
  TESTGETENV(obsolete,no)
  TESTGETENV(hint,yes)
  TESTGETENV(verbose,yes)
  TESTGETENV(debug,yes)
  loc = setlocale(LC_ALL,getenv("LC_ALL"));
  if (loc) 
    adms_message_verbose ("Locale set to %s\n",loc)
  else 
    adms_message_verbose ("Locale unchanged\n")
  if(!adms_file_check_command_line (argc,argv,adms_preprocessor_usage))
  {
    FILE*ifh=NULL;
    GSList*fileNameList=adms_file_get_ifile_from_argv(argc,argv);
    char*fileName=(char*) g_slist_nth_data (fileNameList,0);
    char*tmpFileName;
    if(fileName)
    {
      char*basename=adms_path_get_basename (fileName);
      char*curdir=g_get_current_dir ();
      char*implicitfilename=g_strdup_printf(".%s.adms",basename);
      adms_admsmain_valueto_filename (adms_get_admsmain (),g_strdup(fileName));
      tmpFileName=g_build_filename (curdir,implicitfilename,NULL);
      adms_message_info ("%s-%s %s %s\n",g_get_prgname(),PACKAGE_VERSION,__DATE__,__TIME__)
      ifh =adms_file_open_read(fileName,__FUNCTION__);
      free(implicitfilename);
      free(curdir);
    }
    else
    {
      char *tmpFileName=adms_parse_create_admsimplicitxmlfile ();
      g_slist_foreach(adms_admsmain_valueof_module(adms_get_admsmain()),(GFunc)adms_xml_init_beforexml_cb,NULL);
      adms_xml_load_xml_admsttransform_from_file (tmpFileName);
      adms_evaluate_xmlscripts (argc,argv);
      g_free(tmpFileName);
    }

    if (ifh)
    {
      gboolean parsing_ok;
      p_preprocessor scanner = g_new0(t_preprocessor,1);
      scanner->cur_line_position = 1;
      scanner->cur_char_position = 1;
      scanner->fid = ifh;
      scanner->filename = fileName;
      scanner->buffer = NULL;
      adms_preprocessor_new ();
      adms_preprocessor_get_main()->cr_scanner = scanner;
      adms_preprocessor_get_main()->cr_filename = fileName;
      adms_preprocessor_get_main()->skipp_text = FALSE;
      adms_preprocessor_get_main()->includePath = adms_file_get_ipath_from_argv(argc,argv);
      adms_preprocessor_get_define_from_argv(argc,argv);
      adms_preprocessor_define_add_default("insideADMS");
      parsing_ok = !admspreprocessor_init (tmpFileName,ifh);
      ParserELapsedTime = g_timer_elapsed (mytimer,NULL);
      adms_message_verbose ("[preprocessor-read] elapsed time: %g\n",ParserELapsedTime)
      g_timer_reset (mytimer);
      if(parsing_ok)
      {
        char* header = g_strdup_printf("# 1 \"%s\"\n",adms_preprocessor_get_main()->cr_scanner->filename);
        g_print(header);
        if(adms_preprocessor_get_main()->error)
          adms_message_fatal ("%i Error(s) found during preprocessing\n",adms_preprocessor_get_main()->error)
        else
          adms_message_verbose ("No error found during preprocessing\n")
        adms_preprocessor_get_main()->Text = g_slist_reverse (adms_preprocessor_get_main()->Text);
        adms_preprocessor_text_list_printf(adms_preprocessor_get_main()->Text);
        free(adms_preprocessor_get_main()->cr_scanner);
        BuilderELapsedTime = g_timer_elapsed (mytimer,NULL);
        adms_message_verbose ("[preprocessor-write] elapsed time: %g\n",BuilderELapsedTime)
        g_timer_reset (mytimer);
        if (!adms_preprocessor_get_main()->error)
        {
          adms_parse_veriloga (tmpFileName,argc,argv);
          adms_evaluate_xmlscripts (argc,argv);
          XmlELapsedTime = g_timer_elapsed (mytimer,NULL);
          adms_message_verbose ("[xml] elapsed time: %g\n",XmlELapsedTime)
        }
      }
      else
        adms_message_fatal ("Error found during preprocessing\n")
      free(tmpFileName);
    }
    {
      GSList*l=fileNameList; for(;l;l=l->next)
        free(l->data);
      g_slist_free(fileNameList);
    }
  }
  adms_message_info ("elapsed time: %g\n",ParserELapsedTime+BuilderELapsedTime+XmlELapsedTime)
  g_timer_destroy (mytimer);
  free(g_get_prgname());
  //adms_simulator_free(adms_admsmain_valueof_simulator(adms_get_admsmain ()));
  adms_message_info("admst iterations: %i (%i freed)\n",adms_get_admsmain()->_nbadmstnew,adms_get_admsmain()->_nbadmstdestroy);
/* memorydebug
  if(0){
    GSList*myalladmst=g_slist_reverse(adms_get_admsmain()->_alladmst);
    for(;myalladmst;myalladmst=myalladmst->next)
    {
      p_admst myadmst=(p_admst)myalladmst->data;
      if(myadmst->_adms._freed==adms_adms_enumeration_freed_no) G_BREAKPOINT();
      adms_message_warning("%s:%i: freed=%i\n",myadmst->_adms._file,myadmst->_adms._line,myadmst->_adms._freed);
    }
  }
*/
  adms_admsmain_free(adms_get_admsmain ());
  return 0;
}
