/*
 * RCS Info
 * $Id: xmlProgram.c,v 1.154 2006/03/21 09:55:14 r29173 Exp $
 *
 * Log
 * $Log: xmlProgram.c,v $
 * Revision 1.154  2006/03/21 09:55:14  r29173
 * code clean-up (fix bug when admst variable is null)
 *
 * Revision 1.153  2006/03/20 15:15:52  r29173
 * moved C code from *.y.in to xml implicit file
 *
 * Revision 1.152  2006/03/17 11:15:50  r29173
 * moved some C code to XML code
 *
 * Revision 1.151  2006/03/17 09:05:58  r29173
 * moved attribute 'expression/visible_variable' to 'expression/variable'
 *
 * Revision 1.150  2006/03/15 17:39:29  r29173
 * removed 'instanceofanalogfunction' element.
 * renamed attributes of admstvariable (svalue, evalue)
 * added support to global admst variables
 *
 * Revision 1.149  2006/03/02 10:13:16  r29173
 * fixed message printed when checking xml script version
 *
 * Revision 1.148  2006/02/21 11:07:20  r29173
 * added 'admst:return' to admst language.
 *
 * Revision 1.147  2006/02/03 12:09:18  r29173
 * parse rhs strings in admstpath conditionals
 * In xml scripts $blabla should be now \$blabla
 *
 * Revision 1.146  2006/01/31 15:56:20  r29173
 * avoid use of g_print on long strings (bug in glib?)
 *
 * Revision 1.145  2006/01/20 11:57:26  r29173
 * fixed bug - freed string variable too earlier
 *
 * Revision 1.144  2006/01/10 14:29:59  r29173
 * fixed bug in handling admstpath position(.)
 *
 * Revision 1.143  2006/01/06 13:34:54  r29173
 * fixed admst:variable handling when admst:value-of selects implicit templates
 *
 * Revision 1.142  2006/01/05 14:43:54  r29173
 * fixed core dump when adms_implicit_transforms is not regular file
 *
 * Revision 1.141  2005/12/07 09:35:42  r29173
 * moved XML code back to C code (AE block)
 *
 * Revision 1.140  2005/12/02 17:48:42  r29173
 * cleaned-up admstpath lexical analyzer (lexan)
 *
 * Revision 1.139  2005/12/01 13:12:11  r29173
 * fixed bug in admst memory handling
 *
 * Revision 1.138  2005/11/30 13:59:16  r29173
 * added memory tracker on element admst
 *
 * Revision 1.137  2005/11/25 14:15:25  r29173
 * changed admstpath parser mechanisms
 *
 * Revision 1.136  2005/11/22 09:31:18  r29173
 * renamed attribute admst/path to attributename
 *
 * Revision 1.135  2005/11/18 15:49:39  r29173
 * clean-up code
 *
 * Revision 1.134  2005/11/18 10:08:07  r29173
 * simplified/renamed elements admst, production, productionitem
 *
 * Revision 1.133  2005/11/16 16:01:02  r29173
 * added elements production and productionitem
 *
 * Revision 1.132  2005/11/14 09:56:11  r29173
 * moved C (verilogaYacc.y.in) to XML (admsImplicitTransforms.xml)
 *
 * Revision 1.131  2005/11/09 16:25:22  r29173
 * moved C code to xm code (calc of math/dependent)
 * renamed some functions
 * fixed memory violation (free)
 *
 * Revision 1.130  2005/11/07 17:42:11  r29173
 * renamed some functions - implemented '*' in admstpath
 *
 * Revision 1.129  2005/09/14 15:58:08  r29173
 * renamed admst:templates to admst:template (same for apply-template)
 *
 * Revision 1.128  2005/08/18 10:45:23  r29173
 * renamed admst:choice to admst:choose (admst:choice tolerated)
 *
 * Revision 1.127  2005/08/16 10:24:05  r29173
 * fixed bug in admst:setenv (reported by mentorg)
 *
 * Revision 1.126  2005/08/15 18:00:30  r29173
 * added handling of $(myvariable)
 *
 * Revision 1.125  2005/06/21 08:02:29  r29173
 * renamed adms_set_admsmain to adms_valueto_admsmain
 *
 * Revision 1.124  2005/06/20 06:45:02  r29173
 * debug memory allocation with valgrind
 *
 * Revision 1.123  2005/06/17 16:44:17  r29173
 * debug memory allocation with valgrind
 *
 * Revision 1.122  2005/06/16 07:12:44  r29173
 * debug memory allocation with valgrind
 *
 * Revision 1.121  2005/06/13 16:07:22  r29173
 * simplified admst parser
 *
 * Revision 1.120  2005/06/10 16:18:59  r29173
 * simplified admstpath parser
 *
 * Revision 1.119  2005/06/09 16:54:51  r29173
 * deleted xmlParserNew.c -- SLOWSLOW
 *
 * Revision 1.118  2005/06/02 13:26:41  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.117  2005/06/01 15:30:29  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.116  2005/06/01 12:39:06  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.115  2005/05/30 17:06:20  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.114  2005/05/27 16:30:40  r29173
 * moving code from xmlParserNew.c to xml - added subexpression
 *
 * Revision 1.113  2005/05/25 13:42:40  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.112  2005/05/25 08:27:51  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.111  2005/05/19 17:08:30  r29173
 * moving code from  xmlParserNew.c to xml
 *
 * Revision 1.110  2005/05/10 08:32:45  r29173
 * added admst:attribute transform
 *
 * Revision 1.109  2005/05/09 14:38:33  r29173
 * cleaned-up source directory structure
 *
 * Revision 1.108  2005/05/03 09:35:17  r29173
 * cleaned-up header file dependencies
 *
 * Revision 1.107  2005/05/03 07:58:28  r29173
 * moved admsNS into admsFile
 *
 * Revision 1.106  2005/05/02 16:02:00  r29173
 * fixed bug in memory allocation
 *
 * Revision 1.105  2005/05/02 07:09:24  r29173
 * improved memory usage
 *
 * Revision 1.104  2005/04/29 16:02:36  r29173
 * improved memory usage
 *
 * Revision 1.103  2005/04/25 12:29:33  r29173
 * fixed few memory leak issues (introduced adms.._free)
 *
 * Revision 1.102  2005/04/22 06:54:42  r29173
 * fixed bug - admstpath:position handling
 *
 * Revision 1.101  2005/04/21 07:54:50  r29173
 * removed some usages of adms_strconcat
 *
 * Revision 1.100  2005/04/21 07:04:13  r29173
 * improved memory usage
 *
 * Revision 1.99  2005/04/01 14:16:25  r29173
 * migration to adms-2.x.x: updated version to 2.0.0
 *
 * Revision 1.98  2005/04/01 10:58:46  r29173
 * migration to adms-2.x.x: simplified coding
 *
 * Revision 1.96  2005/03/31 18:12:03  r29173
 * migration to adms-2.x.x: converted to adms2 syntax
 *
 * Revision 1.95  2005/03/24 17:03:27  r29173
 * migration to adms-2.x.x: fixed bugs in admstpath parser
 *
 * Revision 1.94  2005/03/23 13:38:34  r29173
 * migration to adms-2.x.x: added xpath parser
 *
 * Revision 1.93  2005/03/14 17:34:21  r29173
 * migration to adms-2.x.x: start xpath coding; add documentation
 *
 * Revision 1.92  2005/03/11 17:57:53  r29173
 * migration to adms-2.x.x: code clean-up
 *
 * Revision 1.91  2005/03/11 09:04:49  r29173
 * migration to adms-2.x.x: admst:if requires attribute 'test'
 *
 * Revision 1.90  2005/03/10 14:52:36  r29173
 * migration to adms-2.x.x: added /variable/topmodule
 *
 * Revision 1.89  2005/03/07 10:17:17  r29173
 * migration to adms-2.x.x: fixed bug in admsattribute handling
 *
 * Revision 1.88  2005/03/04 18:09:41  r29173
 * migration to adms-2.x.x: added admsxml elements
 *
 * Revision 1.87  2005/02/28 09:22:13  r29173
 * migration to adms-2.x.x: admst:size renamed admst:count
 *
 * Revision 1.86  2005/02/28 08:03:30  r29173
 * migration to adms-2.x.x: admst:version required
 *
 * Revision 1.85  2005/02/26 09:53:15  r29173
 * migration to adms-2.x.x: added admst:new; applied to jacobian
 *
 * Revision 1.84  2005/02/25 15:31:42  r29173
 * migration to adms-2.x.x: code clean-up
 *
 * Revision 1.83  2005/02/25 14:36:50  r29173
 * migration to adms-2.x.x: fixed test vlatovla
 *
 * Revision 1.82  2005/02/25 12:49:36  r29173
 * migration to adms-2.x.x: renamed admst transforms
 *
 * Revision 1.81  2005/02/24 16:28:00  r29173
 * migration to adms-2.x.x: simplified handling of transform/admst
 *
 * Revision 1.80  2005/02/24 11:26:52  r29173
 * migration to adms-2.x.x: introduce element admst created at each transform
 *
 * Revision 1.79  2005/02/22 20:09:21  r29173
 * migration to adms-2.x.x: renamed if:select to if:test
 *
 * Revision 1.78  2005/02/20 11:46:08  r29173
 * migration to adms-2.x.x: renamed device to module
 *
 * Revision 1.77  2005/02/20 11:00:58  r29173
 * migration to adms-2.x.x: renamed devicenode to node
 *
 * Revision 1.76  2005/02/18 16:34:22  r29173
 * migration to adms-2.x.x: changed syntax of admst:open
 *
 * Revision 1.75  2005/02/17 17:00:18  r29173
 * added missing "errno.h"; turned some warnings off; added more stuffs to vlatomml
 *
 * Revision 1.74  2005/02/17 10:59:47  r29173
 * migration to adms-2.x.x: (**) construct is alllowed; better handling of admst messaging
 *
 * Revision 1.73  2005/02/17 08:22:34  r29173
 * migration to adms-2.x.x: fixed bug in preprocessor (line number tracking)
 *
 * Revision 1.72  2005/02/15 15:19:32  r29173
 * migration to adms-2.x.x: use admst:text for all analog//items
 *
 * Revision 1.71  2005/02/14 10:41:17  r29173
 * migration to adms-2.x.x: moved templates to Version.xml
 *
 * Revision 1.70  2005/02/14 09:31:47  r29173
 * migration to adms-2.x.x: removed admst:xmltostring
 *
 * Revision 1.69  2005/02/14 08:44:39  r29173
 * release 1.47.0
 * migration to adms-2.x.x: converted contribution/assignment
 *
 * Revision 1.68  2005/02/01 08:58:33  r29173
 * migration to adms-2.x.x - modified expression stringifier
 *
 * Revision 1.67  2005/01/31 16:48:47  r29173
 * migration to adms-2.x.x - conditional done
 *
 * Revision 1.66  2005/01/30 12:22:15  r29173
 * migration to adms-2.x.x - block 50% done
 *
 * Revision 1.65  2005/01/28 16:32:15  r29173
 * migration to adms-2.x.x - whileloop done
 *
 * Revision 1.64  2005/01/28 09:08:39  r29173
 * migration to adms-2.x.x - started replacement of whileloop
 *
 * Revision 1.63  2005/01/27 11:12:00  r29173
 * migration to adms-2.x.x - fixed namespace (admst)
 *
 * Revision 1.62  2005/01/25 10:15:42  r29173
 * migration to adms-2.x.x - cleaned-up code
 *
 * Revision 1.61  2005/01/24 13:19:24  r29173
 * migration to adms-2.x.x - fixed bugs in evaluate/admst:apply-templates
 *
 * Revision 1.60  2005/01/22 10:54:36  r29173
 * migration to adms-2.x.x - fixed bugs in evaluate/admst:apply-templates
 *
 * Revision 1.58  2005/01/21 16:06:01  r29173
 * migration to adms-2.x.x - cleaned-up evaluate
 *
 * Revision 1.57  2005/01/21 12:34:14  r29173
 * migration to adms-2.x.x - added asserts to admst:transforms
 *
 * Revision 1.56  2005/01/21 10:01:02  r29173
 * migration to adms-2.x.x - better handling of adms_admsttransform_linkto_admsxml
 *
 * Revision 1.55  2005/01/20 17:23:42  r29173
 * migration to adms-2.x.x - better handling of select=.
 *
 * Revision 1.54  2005/01/20 16:29:33  r29173
 * migration to adms-2.x.x - better handling of select=..
 *
 * Revision 1.51  2005/01/20 10:26:37  r29173
 * migration to adms-2.x.x - added debug info
 *
 * Revision 1.50  2005/01/19 09:00:27  r29173
 * migration to adms-2.x.x - fixed bug in apply-templates and admst:if
 *
 * Revision 1.48  2005/01/17 18:12:07  r29173
 * migration to adms-2.x.x - transforms evaluated at runtime
 *
 * Revision 1.47  2005/01/17 14:06:17  r29173
 * migration to adms-2.x.x - handling of datatypename/datatypefamily
 *
 * Revision 1.46  2005/01/17 09:28:00  r29173
 * migration to adms-2.x.x
 *
 * Revision 1.45  2005/01/11 09:57:57  r29173
 * tons of changes - simplify accessor names (valueof, valueto)
 *
 * Revision 1.44  2005/01/06 09:39:45  r29173
 * tons of changes - metaadms.dtd validates adms.xml
 *
 * Revision 1.43  2005/01/03 09:33:01  r29173
 * cleaned-up code
 *
 * Revision 1.42  2004/12/07 09:45:53  r29173
 * release-1.44.0
 * added $get_prev (marat)
 * changed return value of select of xml transforms for regexp handling (laurent)
 * All simulators passed
 *
 * Revision 1.41  2004/12/02 15:16:03  r29173
 * tons of changes - moved code for C to xml
 * *empty* is replaced  by "" -> spectre/zspice failed
 *
 * Revision 1.40  2004/11/23 17:19:27  r29173
 * moved code from xmlParser.c to admsImplicitTransforms.xml
 * started noise code handling
 *
 * Revision 1.39  2004/11/19 12:29:57  r29173
 * renamed _C into CAT
 * saved argc, argv into admsmain element
 * added admst:setenv transform
 *
 * Revision 1.38  2004/11/12 14:18:29  r29173
 * release  1.40.0.0
 * added warning if CR, TAB or LF are used in admst:text transforms
 * all interfaces pass except spectre
 * spectre has improved loadGmin, loadPwl (marat)
 *
 * Revision 1.37  2004/11/10 13:51:46  r29173
 * release 1.39.0
 * tons of changes - moved code to xmlParser.c to admsImplicitTranform.xml
 * ads/mica/zspice/simkit passed except sgp.c (minor bug in previous version)
 * spectre failed (new xml interface - file spectreMODULE.c.xml)
 *
 * Revision 1.36  2004/11/02 08:58:43  r29173
 * default output to stdout in xml programs
 * added predicate:isdefault
 * moved code from xmlProgram.c to admsImplicitTransforms.xml
 *
 * Revision 1.35  2004/11/01 13:21:41  r29173
 * moved code from perl script to cfile
 *
 * Revision 1.34  2004/11/01 09:37:38  r29173
 * changed messaging macros (avoid useless computation of arguments)
 * improved the coding of transforms in xmlProgram.c
 *
 * Revision 1.33  2004/10/29 12:54:03  r29173
 * made more comprehensive the coding of 'transform' element
 *
 * Revision 1.32  2004/10/27 16:11:39  r29173
 * release 1.37.0
 * tons of changes - modify the way settors and gettors are built
 * from adms.xml in order to simplify admsProgram.c
 * added zspice to testbench
 * spectre/ads/mica/zspice/simkit passed
 *
 * Revision 1.31  2004/10/20 15:33:51  r29173
 * tons of changes
 * 1- introduced element whileloop (marat)
 * 2- reshaped the handling of the messaging system
 * 3- fixed bug in admsCheck/Makefile.am
 * 4- started implementation of implicit adms transforms
 *
 * Revision 1.30  2004/10/19 10:24:46  r29173
 * release 1.35.0
 * renamed 'adms rules' to admst:transform (adms namespace)
 * mica/ads/simkit passed
 * spectre failed: removed loadDynamic
 *
 * Revision 1.29  2004/10/18 19:25:36  r29173
 * reverse-order of arguments of callfunctions
 *
 * Revision 1.28  2004/10/18 17:59:39  r29173
 * added handling admst:templates of callfunctions
 *
 * Revision 1.27  2004/10/18 13:45:57  r29173
 * changed prefix of adms 'transforms' from xsl: to admst:
 * renamed 'adms transforms' to 'adms transforms'
 * renamed adms transforms admst:defined and admst:undefined to admst:if
 * introduced SiMKiT to testbench
 * improved handling of predicate 'separator' in admst:join
 * spectre/mica/ads passed
 *
 * Revision 1.25  2004/10/14 10:05:32  r29173
 * fixed bug in setting of _pwd for open/defined/undefined transforms
 * renamed _pwd and _up to _oPwd and _iPwd
 * resolve transform symbol just after creating transform
 *
 * Revision 1.24  2004/10/13 15:24:15  r29173
 * preprocess xml files passed to admsXml with adms_file_getpathname
 *
 * Revision 1.23  2004/10/12 08:33:48  r29173
 * introduced admst:templates and admst:apply-template transforms (NO COMPLETED)
 * implement xml 'set' transform
 *
 * Revision 1.22  2004/10/08 18:40:19  r29173
 * moved element 'simulator' from hard-coded to adms.xml
 *
 * Revision 1.21  2004/10/08 10:46:42  r29173
 * improved implementation of 'Get' stack
 *
 * Revision 1.20  2004/10/07 14:19:31  r29173
 * made more readable the building of xml transforms
 * (not finished!)
 *
 * Revision 1.18  2004/10/01 16:18:57  r29173
 * simplified conversion of xml properties (format="...") ro string.
 *
 * Revision 1.17  2004/10/01 11:47:10  r29173
 * simplified the way strings are transformed to properties
 *
 * Revision 1.16  2004/10/01 09:10:42  r29173
 * removed usage of adms_string_remove_quote
 *
 * Revision 1.15  2004/10/01 08:49:20  r29173
 * moved load*_code from xmlParser.c to xmlProgram.c
 * removed quarks adms_admsttransform_valueof_valid(myadmsttransform) from xmlProgram.c
 *
 * Revision 1.14  2004/09/30 16:43:52  r29173
 * release 1.30.0
 * ads passed
 * mica/spectre failed
 * CHANGES:
 * removed usage of xml transform 'reverse'
 *
 * Revision 1.13  2004/09/30 09:24:47  r29173
 * cleaned up code
 *
 * Revision 1.12  2004/09/29 15:41:13  r29173
 * removed code that hanldes xml transform 'new'
 *
 * Revision 1.11  2004/09/29 13:37:45  r29173
 * cleaned-up code - started implementation of admst:template
 *
 * Revision 1.10  2004/09/23 14:03:54  r29173
 * fixed again extra C comments in RCS header
 *
 * Revision 1.9  2004/09/23 12:50:51  r29173
 * fixed -slash-*empty*-slash in RCS header
 *
 * Revision 1.8  2004/09/23 11:36:58  r29173
 * returns string empty instead of (nil) when a transform returns NULL.
 *
 * Revision 1.7  2004/09/23 09:03:17  r29173
 * started implementation of xpath parser
 * (at the end this file should be replaced by open-source xsl parser)
 *
 * Revision 1.6  2004/09/07 07:44:17  r29173
 * added xslt transform /../../..[ww] where ww is a number
 *
 * Revision 1.5  2004/08/19 16:46:44  r29173
 * cleaned-up i/o file handling
 *
 * Revision 1.4  2004/08/16 10:52:30  r29173
 * changed handling of  (created adms_message_debug)
 *
 * Revision 1.3  2004/08/03 12:33:56  r29173
 * import adms-1.21.0 from local CVS
 *
 * Revision 1.9  2004/07/20 15:00:18  r29173
 * added superelement to adms.xml
 *
 * Revision 1.8  2004/07/19 09:22:56  r29173
 * finished transformation of evaluation->_value into stringlist
 *
 * Revision 1.7  2004/07/16 13:25:34  r29173
 * replaced _C by g_strconcat
 *
 * Revision 1.6  2004/07/14 15:41:20  r29173
 * removed code used to handle GLib tree data structure
 * modify xmlParserNew.c so that only one evaluation is used by
 * tostring in non-expressions
 *
 * Revision 1.5  2004/07/09 14:39:11  r29173
 * removed data structure ns
 *
 * Revision 1.4  2004/07/07 07:31:23  r29173
 * moved definition of macro _C
 * GLib->xml transition: admsProgram.c done
 *
 * Revision 1.3  2004/06/30 16:40:57  r29173
 * renamed all admsObject files to object<Filename>
 *
 * Revision 1.2  2004/05/26 15:06:16  r29173
 * removed treedata->static
 *
 * Revision 1.1.1.1  2004/05/21 12:20:01  r29173
 * recreated cvs data structure (crashed after revision 1.13.0!)
 *
 * Revision 1.55  2004/05/15 10:00:08  r29173
 * simplified handling of variable attributes
 *
 * Revision 1.54  2004/05/13 07:34:50  r29173
 * continue removing GNode* structure
 *
 * Revision 1.53  2004/05/04 08:07:09  r29173
 * added code for @final
 * removed libltdl
 *
 * Revision 1.52  2004/04/22 09:49:13  r29173
 * moved xparser structure into xmlParser
 *
 * Revision 1.51  2004/04/19 20:23:25  r29173
 * simplified macros in xmlNode.h
 *
 * Revision 1.50  2004/04/19 16:24:31  r29173
 * moved code of xparser to xmlParser
 *
 * Revision 1.49  2004/04/19 14:52:19  r29173
 * cleaned-up code
 * added handling of \t in xml files
 *
 * Revision 1.48  2004/04/14 12:48:09  r29173
 * removed code that created dtd files
 * cleaned-up veriloga parser coding
 *
 * Revision 1.47  2004/03/21 10:36:58  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.46  2004/03/08 13:58:07  r29173
 * all code lower-cased
 *
 * Revision 1.45  2004/03/08 08:24:20  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.44  2004/02/18 23:30:46  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.43  2004/02/13 14:28:39  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.42  2004/02/10 16:44:30  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.41  2004/02/06 16:27:19  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.40  2004/02/06 14:52:08  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.39  2004/02/03 12:48:30  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.38  2004/01/30 17:43:23  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.37  2004/01/29 15:49:08  r29173
 * renamed accessors of xmls
 *
 * Revision 1.36  2004/01/21 14:35:46  r29173
 * started implementing code builder in yacc parser
 *
 * Revision 1.35  2004/01/16 10:28:05  r29173
 * fixed handling of infinite value
 *
 * Revision 1.34  2004/01/13 11:28:13  r29173
 * changed coding style
 *
 * Revision 1.33  2004/01/09 16:23:49  r29173
 * cleaned-up use of #include
 *
 * Revision 1.32  2004/01/08 10:28:49  r29173
 * moved code to always.[ch]
 *
 * Revision 1.31  2004/01/07 10:05:30  r29173
 * introduced use of ADMS_MODE_TEST
 *
 * Revision 1.30  2004/01/06 12:35:01  r29173
 * fixed the use of globals: input file and output file
 *
 * Revision 1.29  2004/01/05 11:48:34  r29173
 * no more using macro ADMS_VERSION
 *
 * Revision 1.28  2003/12/17 16:30:11  r29173
 * moved code from *.[ch].in files to simulatorMain.c
 * removed empty *.[ch].in files
 *
 * Revision 1.27  2003/12/12 15:08:35  r29173
 * changed construct (a==NULL) to (!a)
 *
 * Revision 1.26  2003/12/12 14:43:38  r29173
 * changed construct (a==NULL) to (!a)
 *
 * Revision 1.25  2003/12/12 14:33:27  r29173
 * changed construct (a!=NULL) into (a) or (a)?1:0
 *
 * Revision 1.24  2003/12/12 14:14:54  r29173
 * cleaned-up after compilation with CFLAG+=-Wall
 *
 * Revision 1.23  2003/12/11 16:01:54  r29173
 * changed prefix [epst]_ADMS_ to [epst]_
 *
 * Revision 1.22  2003/11/08 17:46:10  r29173
 * re-organized handling of xparsers
 *
 * Revision 1.21  2003/10/06 09:59:45  r29173
 * fixed bugs using adms_xml_verbose when ADMS_XML_VERBOSE is on
 *
 * Revision 1.20  2003/08/27 15:27:12  r29173
 * fixed construct not supported by gcc on linux
 *
 * Revision 1.19  2003/08/26 13:44:58  r29173
 * fixed bug in usage of g_getenv
 *
 * Revision 1.18  2003/08/26 12:26:27  r29173
 * added new transform "getenv"
 *
 * Revision 1.17  2003/08/25 09:23:08  r29173
 * fixed usage of transforms "defined", "undefined"
 * renamed admst:foreach into admst:for-each
 *
 * Revision 1.16  2003/08/04 13:17:34  r29173
 * sync with  changes to adms.xml
 *
 * Revision 1.15  2003/07/22 14:46:06  r29173
 * simplified procedure to create admsObject
 *
 * Revision 1.14  2003/07/11 14:43:31  r29173
 * added handling of "stylesheet" declaration
 *
 * Revision 1.13  2003/07/11 12:52:42  r29173
 * replaced "print" transform by "admst:text"
 *
 * Revision 1.12  2003/07/11 12:43:38  r29173
 * replaced "xpath" transform by "select"
 *
 * Revision 1.11  2003/07/11 12:31:54  r29173
 * replaced "select" transform by "admst:foreach"
 *
 * Revision 1.10  2003/07/11 12:13:49  r29173
 * replaced "get" transform by "admst:value-of"
 *
 * Revision 1.9  2003/07/11 09:58:39  r29173
 * fixed handling of <select xpath="/">
 *
 * Revision 1.8  2003/07/09 21:55:09  r29173
 * skipped qpush-ing data when data is NULL
 *
 * Revision 1.7  2003/07/07 09:29:28  r29173
 * added predicate "options" (can have or-ed or and-ed filter transforms)
 *
 * Revision 1.6  2003/06/26 15:16:09  r29173
 * added feature /simulator/currentdate
 *
 * Revision 1.5  2003/06/25 14:26:14  r29173
 * fixed memory violation (usage of ->_pwd)
 *
 * Revision 1.4  2003/06/23 06:57:55  r29173
 * added /simulator/fullname functionnality
 *
 * Revision 1.3  2003/06/17 12:40:38  r29173
 * handles "." and ".."
 *
 * Revision 1.2  2003/05/21 14:18:02  r29173
 * add rcs info
 *
 */

#include <admsXml/admsXml.h>
#include <admsObject/admsC.h>

#define T(p) !strcmp(adms_admsttransform_valueof_admstname(myadmsttransform),#p)

/*
!isInput&getatleastonce&!setatleastonce                        [e] variable never initialized
isInput&setatleastonce                                         [e] can not assign parameter variable
inModel&!isMParam                                              [e] is not model variable but used/assigned in @model
inModel&variableOPdependent                                    [e] used in @model - can't be operating point dependent
inInstance&variableOPdependent                                 [e] used in @instance - can't be operating point dependent
setinModel&(setinInstance|setinEvaluate|setinNoise|setinFinal) [e] assigned in @model and in another @block
setinInstance&(setinEvaluate|setinNoise|setinFinal)            [e] assigned in @instance and in another @block
notUsed&isInput                                                [i] %s: parameter never used
notUsed&!isInput&isOutput                                      [i] %s: output variable never used
notUsed&!isInput&!isOutput                                     [i] %s: variable never used
*/

#define qgetdata(list) (list?list->data:NULL)
#define Get adms_admsmain_valueof_valueof(adms_get_admsmain())
#define admstfileList adms_admsmain_valueof_admstfile(adms_get_admsmain())
#define admstfile (char*)admstfileList?admstfileList->data:g_strdup("")
#define Templates adms_admsmain_valueof_template(adms_get_admsmain())
#define Transform adms_admsmain_valueof_admsttransform(adms_get_admsmain())
#define GETTRANSFORM(l) p_admsttransform l=qgetdata(Transform);
#define PUSHTRANSFORM(myadmsttransform) qpush(&Transform,myadmsttransform);
#define curTemplateList adms_admsmain_valueof_instanceofadmsttransform(adms_get_admsmain())
#define curTemplateInsideApplyTemplate adms_admsmain_valueof_instanceofadmsttransforminsideapplytemplate(adms_get_admsmain())
#define FOREACH_ADMST(attr) \
  p_production myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_##attr(myadmsttransform));\
  GSList*myl=myproduction->_curadmstlist;\
  for(;myl;myl=myl->next)
#define FOREACH_ADMST_AGAIN(attr) \
  myl=myproduction->_curadmstlist;\
  for(;myl;myl=myl->next)

const void adms_check_version (p_admsttransform myadmsttransform)
{
  char*available=PACKAGE_VERSION;
  char**Available=g_strsplit (available,".",3);
  int available_major;
  int available_minor;
  int available_micro;
  char*required=adms_admsttransform_valueof_version(myadmsttransform);
  char**Required=g_strsplit (required,".",3);
  int required_major;
  int required_minor;
  int required_micro;

  if(!(Available[0]&&Available[1]&&Available[2]))
    adms_message_fatal("%s: invalid version number\n",adms_admsttransform_getuid(myadmsttransform))
  errno=0; available_major=strtod(Available[0],NULL);
  if(errno) adms_message_fatal("%s: invalid version number\n",adms_admsttransform_getuid(myadmsttransform))
  errno=0; available_minor=strtod(Available[1],NULL);
  if(errno) adms_message_fatal("%s: invalid version number\n",adms_admsttransform_getuid(myadmsttransform))
  errno=0; available_micro=strtod(Available[2],NULL);
  if(errno) adms_message_fatal("%s: invalid version number\n",adms_admsttransform_getuid(myadmsttransform))

  if(!(Required[0]&&Required[1]&&Required[2]))
    adms_message_fatal("%s: invalid version number\n",adms_admsttransform_getuid(myadmsttransform))
  errno=0; required_major=strtod(Required[0],NULL);
  if(errno) adms_message_fatal("%s: invalid version number\n",adms_admsttransform_getuid(myadmsttransform))
  errno=0; required_minor=strtod(Required[1],NULL);
  if(errno) adms_message_fatal("%s: invalid version number\n",adms_admsttransform_getuid(myadmsttransform))
  errno=0; required_micro=strtod(Required[2],NULL);
  if(errno) adms_message_fatal("%s: invalid version number\n",adms_admsttransform_getuid(myadmsttransform))

  if (required_major > available_major)
    adms_message_fatal("%s: adms version too old (required:%s.%s.%s available:%s)\n",
      adms_admsttransform_getuid(myadmsttransform),Required[0],Required[1],Required[2],available)
  if (required_major < available_major)
    adms_message_fatal("%s: adms version too new (required:%s.%s.%s available:%s)\n",
      adms_admsttransform_getuid(myadmsttransform),Required[0],Required[1],Required[2],available)
  if (required_minor > available_minor)
    adms_message_fatal("%s: adms version too old (required:%s.%s.%s available:%s)\n",
      adms_admsttransform_getuid(myadmsttransform),Required[0],Required[1],Required[2],available)
  if (required_minor < available_minor)
    adms_message_fatal("%s: adms version too new (required:%s.%s.%s available:%s)\n",
      adms_admsttransform_getuid(myadmsttransform),Required[0],Required[1],Required[2],available)
  if (required_micro > available_micro)
    adms_message_warning("%s: adms version too old (required:%s.%s.%s available:%s)\n",
      adms_admsttransform_getuid(myadmsttransform),Required[0],Required[1],Required[2],available)
}

static gboolean adms_xml_valueof_format_variable (GSList**Property,const char**curPtr,const char**prevPtr)
{
  if(**curPtr=='$')
  {
    int lenB=*curPtr-*prevPtr;
    int hasParen=0;
    if(lenB)
      qpush (Property,g_strndup(*prevPtr,lenB));
    *prevPtr=*curPtr;
    (*curPtr)++;
    if(**curPtr=='(')
    {
      (*curPtr)++; 
      hasParen=1;
    }
    if(hasParen)
    {
      while(hasParen&&**curPtr!='"')
      {
        if(**curPtr==')')
          hasParen--;
        else if(**curPtr=='(')
          hasParen++;
        if(hasParen)
          (*curPtr)++;
      }
      if(!hasParen&&**curPtr==')')
      {
        char*varname;
        lenB=*curPtr-((*prevPtr)+1);
        varname=g_strndup((*prevPtr)+1,lenB);
        *varname='$';
        qpush (Property,varname);
        (*curPtr)++;
      }
      else
        return 0;
    }
    else
    {
      while(isalnum(**curPtr)||**curPtr=='_')
        (*curPtr)++;
      lenB=*curPtr-*prevPtr;
      qpush (Property,g_strndup(*prevPtr,lenB));
    }
    *prevPtr=*curPtr;
    return 1;
  }
  return 0;
}
static int adms_xml_valueof_format_tabulation (GSList**Property,const char**curPtr,const char**prevPtr)
{
  const char*cPtr="\n\t\r";
  while(*cPtr)
  {
    if(**curPtr==*cPtr)
    {
      int lenB=*curPtr-*prevPtr;
      if(lenB)
        qpush (Property,g_strndup(*prevPtr,lenB));
      if(*cPtr=='\n' )
        qpush (Property,g_strdup("\\n"));
      else if(*cPtr=='\r' )
        qpush (Property,g_strdup("\\r"));
      else if(*cPtr=='\t' )
        qpush (Property,g_strdup("\\t"));
      else
        adms_message_fatal("%s: internal error",__FUNCTION__);
      (*curPtr)++; *prevPtr=*curPtr;
      return 1;
    }
    cPtr++;
  }
  return 0;
}
static int adms_xml_valueof_format_formater (GSList**Property,const char**curPtr,const char**prevPtr)
{
  char c;
  c='%';
  if(**curPtr==c && *(*curPtr+1))
  {
    int lenB=*curPtr-*prevPtr;
    if(*(*curPtr+1)==c) /*%% becomes %*/
      qpush (Property,g_strndup(*prevPtr,lenB+1));
    else
    {
      if(lenB)
        qpush (Property,g_strndup(*prevPtr,lenB));
      qpush (Property,g_strndup(*curPtr,2));
    }
    (*curPtr)++; (*curPtr)++; *prevPtr=*curPtr;
    return 1;
  }
  c='\\';
  if(**curPtr==c && *(*curPtr+1))
  {
    int lenB=*curPtr-*prevPtr;
    if(*(*curPtr+1)=='n' || *(*curPtr+1)=='r' || *(*curPtr+1)=='t' || *(*curPtr+1)=='$') /*\n|\r|\t|\$ preserved*/
    {
      if(lenB)
        qpush (Property,g_strndup(*prevPtr,lenB));
      qpush (Property,g_strndup(*curPtr,2));
    }
    else  /*\w becomes w*/
    {
      char*newval;
      newval=g_strndup(*prevPtr,lenB+1);
      newval[lenB]=*(*curPtr+1);
      qpush (Property,newval);
    }
    (*curPtr)++; (*curPtr)++; *prevPtr=*curPtr;
    return 1;
  }
  return 0;
}
static void adms_xml_valueof_format (GSList**Property,const char*format)
{
  const char*cur=format;
  const char*prev=cur;
  if(!strcmp(cur,""))
  {
    qpush (Property,g_strdup(""));
    return;
  }
  while(*cur)
  {
    adms_xml_valueof_format_tabulation (Property,&cur,&prev)
    ||
    adms_xml_valueof_format_formater (Property,&cur,&prev)
    ||
    adms_xml_valueof_format_variable (Property,&cur,&prev)
    ||
    cur++;
  }
  if(*prev)
    qpush (Property,g_strdup(prev));
}
#define predicate_free(txt) free(txt)
static void callTemplate(p_admst myadmst,p_adms myelement);
void free_production(p_production myproduction)
{
  GSList*myall=myproduction->_alladmst;
  for(;myall;myall=myall->next)
  {
    p_admst myadmst=adms_admst(myall->data);
    adms_admst_free(myadmst);
  }
  g_slist_free(myproduction->_alladmst);
  //adms_production_free(myproduction);
  free(myproduction->_admstpath);
  //free(myproduction->_stringposition);
  //free(myproduction->_text);
  //free(myproduction->_tokentext);
  free(myproduction);
}
static char*adms_admsstack_sprintf_impl (p_admsttransform myadmsttransform,GSList*PropertyPtr)
{
  char*myformat=(char*)PropertyPtr->data;
  char*newvalue=NULL;
  if(!strcmp(myformat,"%s"))
  {
    if(Get)
    {
      p_admst myadmst=(p_admst) qpull(&Get);
      if(!strcmp(adms_admsttransform_valueof_admstname(adms_admst_valueof_admsttransform(myadmst)),"admst:getenv"))
      {
        char*name=adms_admsstack_sprintf(adms_admst_valueof_admsttransform(myadmst),adms_admsttransform_valueof_name(adms_admst_valueof_admsttransform(myadmst)),NULL);
        const char*myenv=g_getenv(name);
        if(myenv)
          newvalue=g_strdup(myenv);
        else
          adms_message_fatal("missing shell variable %s %s\n",adms_admsttransform_valueof_name(adms_admst_valueof_admsttransform(myadmst)),adms_admsttransform_getuid(adms_admst_valueof_admsttransform(myadmst)))
        predicate_free(name);
      }
      else if(adms_admst_valueof_size(myadmst)!=adms_admst_enumeration_size_list)
      {
        e_admst_datatypename mydatatypename=adms_admst_valueof_datatypename(myadmst);
        int mydatatypefamily=adms_admst_valueof_datatypefamily(myadmst);
        if((mydatatypename==adms_admst_enumeration_datatypename_enumeration))
        {
          p_valuetostring myvaluetostring=adms_admst_valueof_tostring((myadmst));
          newvalue=g_strdup_printf("%s",(char*)myvaluetostring(myadmsttransform,adms_admst_valueof_item(myadmst)));
        }
        else if((mydatatypename==adms_admst_enumeration_datatypename_integer))
          newvalue=g_strdup_printf("%i",adms_admst_valueof_item(myadmst));
        else if(!adms_admst_valueof_item(myadmst))
          newvalue=g_strdup("");
        else if((mydatatypefamily==adms_admst_enumeration_datatypefamily_reference)
          &&(adms_adms_valueof_datatypename(adms_admst_valueof_item(myadmst))==adms_adms_enumeration_datatypename_expression))
        {
          adms_message_obsolete_continue("At: %s\n",adms_admst_getuid(myadmst))
          adms_message_obsolete_continue("Please replace admst transform by:\n")
          adms_message_obsolete_continue("  <admst:value-of select=\"%s/tree/adms/datatypename\"/>\n",adms_admst_valueof_attributename(myadmst))
          adms_message_obsolete_continue("  <admst:apply-templates select=\"%s/tree\" match=\"%%s\"/>\n",adms_admst_valueof_attributename(myadmst))
          adms_message_obsolete_continue("  <admst:value-of select=\"/simulator/tmp\"/>\n")
          adms_message_obsolete("  Old construct will NOT be supported in adms-2.1.3 and future releases\n")
          callTemplate(myadmst,adms_expression_valueof_tree(adms_admst_valueof_item(myadmst)));
          newvalue=g_strdup_printf("%s",adms_simulator_valueof_tmp(adms_admsmain_valueof_simulator(adms_get_admsmain())));
        }
        else if((mydatatypefamily==adms_admst_enumeration_datatypefamily_reference)
          &&!strcmp(adms_admst_valueof_attributename(myadmst),"arguments"))
        {
          adms_message_obsolete_continue("At: %s\n",adms_admst_getuid(myadmst))
          adms_message_obsolete_continue("Please replace admst transform by:\n")
          adms_message_obsolete_continue("  <admst:value-of select=\"%s/adms/datatypename\"/>\n",adms_admst_valueof_attributename(myadmst))
          adms_message_obsolete_continue("  <admst:apply-templates select=\"%s\" match=\"%%s\"/>\n",adms_admst_valueof_attributename(myadmst))
          adms_message_obsolete_continue("  <admst:value-of select=\"/simulator/tmp\"/>\n")
          adms_message_obsolete("  Old construct will NOT be supported in adms-2.1.3 and future releases\n")
          callTemplate(myadmst,adms_admst_valueof_item(myadmst));
          newvalue=g_strdup_printf("%s",adms_simulator_valueof_tmp(adms_admsmain_valueof_simulator(adms_get_admsmain())));
        }
        else if((mydatatypename==adms_admst_enumeration_datatypename_string))
          newvalue=(char*)adms_admst_valueof_item(myadmst);
        else if((mydatatypefamily==adms_admst_enumeration_datatypefamily_reference) )   
          newvalue=g_strdup_printf("%s",h(adms_admst_valueof_item(myadmst)));
      }
      else
        adms_message_fatal("%s: cannot stringify %s",adms_admsttransform_getuid(myadmsttransform),adms_admst_getuid(myadmst))
      adms_admst_free(myadmst);
    }
    else
      adms_message_fatal("Get has no more element! %s",adms_admsttransform_getuid(myadmsttransform))
  }
  else if(!strcmp(myformat,"\\n"))
    newvalue=g_strdup_printf ("\n");
  else if(!strcmp(myformat,"\\r"))
    newvalue=g_strdup_printf ("\r");
  else if(!strcmp(myformat,"\\t"))
    newvalue=g_strdup_printf ("\t");
  else if(!strcmp(myformat,"\\$"))
    newvalue=g_strdup_printf ("$");
  else if(*myformat=='$')
  {
    p_instanceofadmsttransform myinstanceofadmsttransform=curTemplateList?curTemplateList->data:NULL;
    char*name=adms_admsstack_sprintf(myadmsttransform,g_strdup(myformat+1),NULL);
    p_admstvariable myadmstvariable;
    if(myinstanceofadmsttransform&&(myadmstvariable=adms_instanceofadmsttransform_list_variable_lookup_by_id(myinstanceofadmsttransform,name)))
      newvalue=g_strdup_printf("%s",adms_admstvariable_valueof_svalue(myadmstvariable));
    else if(myadmstvariable=adms_admsmain_list_variable_lookup_by_id(adms_get_admsmain(),name))
      newvalue=g_strdup_printf("%s",adms_admstvariable_valueof_svalue(myadmstvariable));
    else
    {
      adms_message_obsolete_continue("%s: admst variable $%s is undefined\n",h(adms_adms(myadmsttransform)),name)
      adms_message_obsolete("%s: if you meant 'literal identifier' please prepend it with symbol '\\'\n",h(adms_adms(myadmsttransform)),myformat)
      newvalue=g_strdup_printf("%s",myformat);
    }
    free(name);
  }
  else
  {
    newvalue=malloc((strlen(myformat)+1)*sizeof(myformat));
    strcpy(newvalue,myformat);
  }
  free(myformat);
  return newvalue;
}
char*adms_admsstack_sprintf (p_admsttransform myadmsttransform,char*pvalue,int*isstring)
{
  if(!strcmp(pvalue,"%p"))
  {
    if(Get)
    {
      p_admst myadmst=(p_admst) qpull (&Get);
      p_adms item=adms_admst_valueof_item(myadmst);
      adms_admst_free(myadmst);
      if(isstring) *isstring=0;
      return (char*)item;
    }
    adms_message_fatal("Get has no more element! %s",adms_admsttransform_getuid(myadmsttransform))
  }
  if(isstring) *isstring=1;
  GSList*Property=NULL;
  GSList*Value=NULL;
  char*concat;
  adms_xml_valueof_format (&Property,pvalue);
  int l=1;
  char*trailingConcat;
  Property=g_slist_reverse(Property);
  GSList*PropertyPtr; for(PropertyPtr=Property;PropertyPtr;PropertyPtr=PropertyPtr->next)
  {
    char* newvalue=adms_admsstack_sprintf_impl (myadmsttransform,PropertyPtr);
    qpush(&Value,newvalue);
    l+=strlen(newvalue);
  }
  g_slist_free(Property);
  Value=g_slist_reverse(Value);
  concat=g_new(char,l);
  trailingConcat=concat;
  GSList*listPtr; for(listPtr=Value;listPtr;listPtr=listPtr->next)
  {
    register char *s=(char*)listPtr->data;
    trailingConcat=g_stpcpy(trailingConcat,s);
    free(listPtr->data);
  }
  g_slist_free(Value);
  return concat;
}
static void adms_admsstack_printf (p_admsttransform myadmsttransform,char*pvalue)
{
  GSList*Property=NULL;
  adms_xml_valueof_format (&Property,pvalue);
  Property=g_slist_reverse(Property);
  GSList*PropertyPtr; for(PropertyPtr=Property;PropertyPtr;PropertyPtr=PropertyPtr->next)
  {
    char* newvalue=adms_admsstack_sprintf_impl (myadmsttransform,PropertyPtr);
    g_print("%s",newvalue);
    g_free(newvalue);
  }
  g_slist_free(Property);
}
static int is_admst (const char*admstname)
{
  if((strlen(admstname)>=5)&&!strncmp(admstname,"admst",5))
    return 1;
  return 0;
}
static void adms_xml_program_start_element_handler (GMarkupParseContext *context,
const char*admstname, const char**predicate_names, const char**predicate_values, gpointer usrdata, GError **error)
{
  int i=0;
  int l=0;
  int c=0;
  GETTRANSFORM(Parent)
  p_admsttransform myadmsttransform;
  g_markup_parse_context_get_position (context,&l,&c);
  myadmsttransform=adms_admsttransform_new (g_strdup(admstfile),l,g_strdup(admstname),Parent);
  if(T(admst:templates)|T(admst:template))
  {
    if(Parent&&!strcmp(adms_admsttransform_valueof_admstname(Parent),"admst"))
      qpush (&Templates,myadmsttransform);
    else
      adms_message_fatal ("admst:template should be child of element <admst/> - see %s\n",adms_admsttransform_getuid(myadmsttransform))
    adms_message_debug ("templates:append(%s)\n",adms_admsttransform_getuid(myadmsttransform))
  }
  else if(!T(admst))
  {
    adms_message_debug ("append(%s) to %s\n",adms_admsttransform_getuid(myadmsttransform),adms_admsttransform_getuid(Parent))
    qpush (&(adms_admsttransform_valueof_children(Parent)),myadmsttransform);
  }
  if(is_admst(admstname))
  {
    while (predicate_names[i])
    {
      #define SET(att) else if(!strcmp(predicate_names[i],#att)) adms_admsttransform_valueto_##att(myadmsttransform,g_strdup(predicate_values[i]));
      if(0) {}
      SET(select) SET(mode) SET(match) SET(required) SET(breakpoint) SET(debug) SET(separator)
      SET(from) SET(to) SET(list) SET(into) SET(name) SET(value) SET(format) SET(onduplicate) SET(probe)
      SET(file) SET(version) SET(arguments) SET(datatype) SET(test)
      else if(!strcmp(predicate_names[i],"xmlns:admst")) {}
      else if(!strcmp(predicate_names[i],"xmlns:m")) {}
      else if(!strcmp(predicate_names[i],"xmlns")) {}
      else
        adms_message_fatal("%s:%i: unknown attribute %s=\"%s\"\n",admstfile,l,predicate_names[i],predicate_values[i])
      ++i;
    }
  }
  else
  {
    GSList *Attribute=NULL;
    while (predicate_values[i])
    {
      p_attribute myattribute=adms_attribute_new(g_strdup_printf("%s",predicate_names[i]));
      adms_attribute_valueto_value(myattribute,g_strdup_printf("%s",predicate_values[i]));
      Attribute=g_slist_prepend (Attribute,myattribute);
      ++i;
    }
    adms_admsttransform_valueto_attribute(myadmsttransform,g_slist_reverse(Attribute));
  }
  PUSHTRANSFORM(myadmsttransform)
}

static void adms_xml_program_end_element_handler
(GMarkupParseContext *c,const char*admstname,gpointer d,GError **err)
{
  GETTRANSFORM(myadmsttransform)
  adms_admsttransform_valueto_children(myadmsttransform,g_slist_reverse(adms_admsttransform_valueof_children(myadmsttransform)));
#define HAS(item) if(!adms_admsttransform_valueof_##item(myadmsttransform))\
  adms_message_fatal("  assert=has(" #item ") failed %s\n",adms_admsttransform_getuid(myadmsttransform)) 
#define NO(item) if(adms_admsttransform_valueof_##item(myadmsttransform))\
  adms_message_fatal("  assert=no(" #item ") failed %s\n",adms_admsttransform_getuid(myadmsttransform)) 
#define OBSOLETE(obsolete,new) if(T(obsolete))\
  adms_message_obsolete("%s: please use "#new" instead\n",adms_admsttransform_getuid(myadmsttransform)) 
  if(!is_admst(adms_admsttransform_valueof_admstname(myadmsttransform)))
  { }
  else if(T(admst))
  { NO(select) HAS(version) }
  else if(T(admst:for-each))
  { HAS(select) NO(test) }
  else if(T(admst:join))
  { HAS(select) NO(test) }
  else if(T(admst:value-of))
  { NO(format) NO(children) HAS(select) }
  else if(T(admst:if-inside))
  { HAS(children) HAS(list) HAS(select) }
  else if(T(admst:if-not-inside))
  { HAS(children) HAS(list) HAS(select) }
  else if(T(admst:choice)||T(admst:choose))
  { OBSOLETE(admst:choice,admst:choose) NO(select) NO(test) }
  else if(T(admst:when))
  { HAS(test) NO(select) }
  else if(T(admst:otherwise))
  { NO(select) NO(test) }
  else if(T(admst:if))
  { HAS(children) HAS(test) NO(select) }
  else if(T(admst:templates)|T(admst:template))
  { OBSOLETE(admst:templates,admst:template) NO(select) HAS(match) }
  else if(T(admst:apply-template)|T(admst:apply-templates))
  { OBSOLETE(admst:apply-template,admst:apply-templates) HAS(select) HAS(match) }
  else if(T(admst:return))
  { HAS(name) NO(children) HAS(value) }
  else if(T(admst:attribute))
  { HAS(children) HAS(name) }
  else if(T(admst:variable))
  { NO(children) HAS(name) }
  else if(T(admst:text))
  { NO(children) HAS(format) NO(select) }
  else if(T(admst:new))
  { HAS(datatype) HAS(arguments) NO(select) }
  else if(T(admst:pull))
  { NO(children) HAS(select) }
  else if(T(admst:push))
  { NO(children) HAS(select) HAS(into) }
  else if(T(admst:reset))
  { NO(children) HAS(select) }
  else if(T(admst:value-to))
  { HAS(value) HAS(select) }
  else if(T(admst:count))
  { HAS(select) }
  else if(T(admst:reverse))
  { HAS(select) }
  else if(T(admst:open))
  { HAS(file) NO(select) }
  else if(T(admst:setenv))
  { NO(children) NO(select) }
  else if(T(admst:getenv))
  { NO(children) NO(select) }
  else if(T(admst:copy))
  { NO(children) NO(select) }
  else if(T(admst:assert))
  { NO(select) NO(children) HAS(test) HAS(format) }
  else if(T(admst:message))
  { NO(select) NO(children) HAS(format) }
  else if(T(admst:warning))
  { NO(select) NO(children) HAS(format) }
  else if(T(admst:error))
  { NO(select) NO(children) HAS(format) }
  else if(T(admst:fatal))
  { NO(select) NO(children) HAS(format) }
  else
    adms_message_fatal ("%s: unknown transform\n",adms_admsttransform_getuid (myadmsttransform))
  if(!T(admst))
    (void) qpull(&Transform);
}
#define _ISLIST (adms_admst_valueof_size(myadmst)==adms_admst_enumeration_size_list)
#define _ISSCALAR (adms_admst_valueof_size(myadmst)!=adms_admst_enumeration_size_list)
#define SIZE_scalar if(_ISLIST)\
  adms_message_fatal("  assert=size(scalar) failed %s\n",adms_admsttransform_getuid(myadmsttransform)) 
#define SIZE_list(myadmst) if(_ISSCALAR)\
  adms_message_fatal("  assert=size(list) failed %s\n",adms_admsttransform_getuid(myadmsttransform)) 
static int xmltext_isspace (const char*text)
{
  const char*cPtr=text;
  while(*cPtr)
  {
    if(!g_ascii_isspace(*cPtr))
      return 0;
    cPtr++;
  }
  return 1;
}
static void adms_xml_program_text_handler
(GMarkupParseContext*context, const char*text, gsize text_len, gpointer user_data, GError **error)
{
  if(!xmltext_isspace(text))
  {
    GETTRANSFORM(Parent)
    p_admsttransform myadmsttransform=adms_admsttransform_new(g_strdup(admstfile),adms_admsttransform_valueof_l(Parent),g_strdup("admst:text"),Parent);
    qpush (&(adms_admsttransform_valueof_children(Parent)),myadmsttransform);
    adms_admsttransform_valueto_format(myadmsttransform,g_strdup_printf("%s",text));
  }
}
static void adms_xml_program_error_handler(GMarkupParseContext *context, GError *error, gpointer user_data)
{
  adms_message_info("%s\n", error->message)
}
static GMarkupParser parser={
  adms_xml_program_start_element_handler,
  adms_xml_program_end_element_handler,
  adms_xml_program_text_handler,
  NULL,
  adms_xml_program_error_handler
};

#define CHILDOF(admst)  GSList*l;for(l=adms_admsttransform_valueof_children(admst);l;l=l->next)
#define E_TEMPLATE      {CHILDOF(mytemplate)  adms_admst_evaluate(adms_admsttransform(l->data),myadmst);}
#define E_CHILD_WITH_UP {CHILDOF(mychild)     adms_admst_evaluate(adms_admsttransform(l->data),myup    );}
#define E_              {CHILDOF(myadmsttransform) adms_admst_evaluate(adms_admsttransform(l->data),myadmst);}
#define E_WITH_UP       {CHILDOF(myadmsttransform) adms_admst_evaluate(adms_admsttransform(l->data),myup    );}

static void adms_admst_evaluate(p_admsttransform myadmsttransform,p_admst myup)
{
  if(!myup)
    adms_message_fatal("%s: myup==NULL!",adms_admsttransform_getuid(myadmsttransform)) 
  if(adms_admsttransform_valueof_breakpoint(myadmsttransform))
    G_BREAKPOINT();
  if(adms_admsttransform_valueof_debug(myadmsttransform))
    adms_message_info ("%s\n",h(adms_adms(myadmsttransform)))
  adms_message_debug ("%s\n",adms_admsttransform_getuid(myadmsttransform))
  if(!is_admst(adms_admsttransform_valueof_admstname(myadmsttransform)))
  {
    GSList* l;
    g_print("<%s",adms_admsttransform_valueof_admstname(myadmsttransform));
    GSList *Attribute=adms_admsttransform_valueof_attribute(myadmsttransform);
    while (Attribute)
    {
      p_attribute myattribute=(p_attribute)Attribute->data;
      g_print(" %s=\"",adms_attribute_valueof_name(myattribute));
      g_print("%s",adms_admsstack_sprintf (myadmsttransform,adms_attribute_valueof_value(myattribute),NULL));
      g_print("\"");
      Attribute=Attribute->next;
      if(!strcmp(adms_attribute_valueof_name(myattribute),"debug"))
        adms_message_info ("%s\n",h(adms_adms(myadmsttransform)))
      if(!strcmp(adms_attribute_valueof_name(myattribute),"breakpoint"))
        G_BREAKPOINT();
    }
    for(l=(GSList*)adms_admsttransform_valueof_children(myadmsttransform);l;l=l->next)
    {
      p_admsttransform mychild=adms_admsttransform(l->data);
      if(!strcmp(adms_admsttransform_valueof_admstname(mychild),"admst:attribute"))
      {
        char*name=adms_admsstack_sprintf(mychild,adms_admsttransform_valueof_name(mychild),NULL);
        g_print(" %s=\"",name);
        E_CHILD_WITH_UP
        g_print("\"");
      }
    }
    g_print(">\n");
    for(l=(GSList*)adms_admsttransform_valueof_children(myadmsttransform);l;l=l->next)
    {
      p_admsttransform mychild=adms_admsttransform(l->data);
      if(!!strcmp(adms_admsttransform_valueof_admstname(mychild),"admst:attribute"))
        adms_admst_evaluate(mychild,myup);
    }
    g_print("</%s>\n",adms_admsttransform_valueof_admstname(myadmsttransform));
  }
  else if(T(admst))
  {
    adms_check_version (myadmsttransform);
    E_WITH_UP
  }
  else if(T(admst:for-each))
  {
    FOREACH_ADMST(select)
    {
      p_admst myadmst=adms_admst(myl->data);
      E_
    }
    free_production(myproduction);
  }
  else if(T(admst:join))
  {
    char*separator;
    if(adms_admsttransform_valueof_separator(myadmsttransform))
      separator=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_separator(myadmsttransform),NULL);
    else
      separator=g_strdup(",\n");
    FOREACH_ADMST(select)
    {
      p_admst myadmst=adms_admst(myl->data);
      E_
      if(myl->next)
        g_print("%s",separator);
    }
    predicate_free(separator);
    free_production(myproduction);
  }
#define CLONE(myadmst)\
  p_admst mycloneadmst=adms_admst_new(myadmst->_admsttransform,myadmst->_absolute->_previous,myadmst->_absolute->_attributename);\
  mycloneadmst->_item=myadmst->_item;\
  mycloneadmst->_fromstring=myadmst->_fromstring;\
  mycloneadmst->_tostring=myadmst->_tostring;\
  mycloneadmst->_datatypefamily=myadmst->_datatypefamily;\
  mycloneadmst->_datatypename=myadmst->_datatypename;\
  mycloneadmst->_attributename=g_strdup(myadmst->_attributename);\
  mycloneadmst->_size=myadmst->_size;
  else if(T(admst:value-of))
  {
    p_production myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_select(myadmsttransform));
    if(myproduction->_admstaslist)
    {
      CLONE(myproduction->_admstaslist->_absolute)
      qpush(&Get,mycloneadmst);
    }
    else if(myproduction->_curadmstlist)
    {
      GSList*myl=myproduction->_curadmstlist;
      for(;myl;myl=myl->next)
      {
        p_admst myadmst=adms_admst(myl->data);
        CLONE(myadmst->_absolute)
        if(adms_admst_valueof_item(mycloneadmst)&&_ISSCALAR&&(adms_admst_valueof_datatypename(mycloneadmst)==adms_admst_enumeration_datatypename_string))
        {
          char*buffer=malloc((strlen((char*)adms_admst_valueof_item(mycloneadmst))+1)*sizeof(char));
          strcpy(buffer,(char*)adms_admst_valueof_item(mycloneadmst));
          adms_admst_valueto_item(mycloneadmst,(p_adms)buffer);
        }
        qpush(&Get,mycloneadmst);
      }
    }
    else
      qpush(&Get,NULL);
    free_production(myproduction);
  }
  else if(T(admst:if-inside))
  {
    p_admst mylistadmst=NULL;
    if(!strcmp(adms_admsttransform_valueof_list(myadmsttransform),"%p"))
    {
      if(Get)
        mylistadmst=(p_admst) qpull (&Get);
      else
      {
        adms_message_fatal("Get has no more element!\n")
        adms_message_fatal("'see %s\n",adms_admsttransform_getuid(myadmsttransform))
      }
    }
    else
    {
      adms_message_fatal_continue("'list' should be exactly '%%p'\n")
      adms_message_fatal("'see %s\n",adms_admsttransform_getuid(myadmsttransform))
    }
    GSList* mylist;
    if(mylistadmst)
      mylist=(GSList*)(((GSList*)mylistadmst->_item));
    else
      mylist=NULL;
    p_production myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_select(myadmsttransform));
    if(myproduction->_admstaslist)
    {
      int isEmpty=1;
      GSList* selected=(GSList*)(adms_admst_valueof_item(myproduction->_admstaslist));
      while(selected&&isEmpty)
      {
        isEmpty=(g_slist_find_custom(mylist,adms_probe(selected->data),(GCompareFunc)adms_probe_cmp)!=NULL);
        selected=selected->next;
      }
      if(!isEmpty)
        E_WITH_UP
    }
    else if(myproduction->_curadmstlist&&myproduction->_curadmstlist->data&&adms_admst_valueof_item(myproduction->_curadmstlist->data))
    {
      if(g_slist_find_custom(mylist,adms_admst_valueof_item(myproduction->_curadmstlist->data),(GCompareFunc)adms_probe_cmp))
        E_WITH_UP
    }
    free_production(myproduction);
    adms_admst_free(mylistadmst);
  }
  else if(T(admst:if-not-inside))
  {
    p_admst mylistadmst=NULL;
    if(!strcmp(adms_admsttransform_valueof_list(myadmsttransform),"%p"))
    {
      if(Get)
        mylistadmst=(p_admst) qpull (&Get);
      else
        adms_message_fatal("Get has no more element! %s",adms_admsttransform_getuid(myadmsttransform))
    }
    else
    {
      adms_message_fatal_continue("'list' should be exactly '%%p'\n")
      adms_message_fatal("'see %s\n",adms_admsttransform_getuid(myadmsttransform))
    }
    GSList* mylist;
    if(mylistadmst)
      mylist=(GSList*)(((GSList*)mylistadmst->_item));
    else
      mylist=NULL;
    p_production myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_select(myadmsttransform));
    if(myproduction->_admstaslist)
    {
      int isEmpty=1;
      GSList* selected=(GSList*)(adms_admst_valueof_item(myproduction->_admstaslist));
      while(selected&&isEmpty)
      {
        isEmpty=(g_slist_find_custom(mylist,adms_probe(selected->data),(GCompareFunc)adms_probe_cmp)!=NULL);
        selected=selected->next;
      }
      if(isEmpty)
        E_WITH_UP
    }
    else if(myproduction->_curadmstlist&&myproduction->_curadmstlist->data&&adms_admst_valueof_item(myproduction->_curadmstlist->data))
    {
      if(!g_slist_find_custom(mylist,adms_admst_valueof_item(myproduction->_curadmstlist->data),(GCompareFunc)adms_probe_cmp))
        E_WITH_UP
    }
    else
      E_WITH_UP
    free_production(myproduction);
    adms_admst_free(mylistadmst);
  }
  else if(T(admst:choice)||T(admst:choose))
  {
    GSList*l; for(l=(GSList*)adms_admsttransform_valueof_children(myadmsttransform);l;l=l->next)
    {
      p_admsttransform mychild=adms_admsttransform(l->data);
      if(adms_admsttransform_valueof_breakpoint(mychild))
        G_BREAKPOINT();
      if(!strcmp(adms_admsttransform_valueof_admstname(mychild),"admst:when"))
      {
        p_production myproduction=adms_admstpath_evaluate(mychild,myup,adms_admsttransform_valueof_test(mychild));
        GSList*myl=myproduction->_curadmstlist;
        if(myl&&adms_admst(myl->data)->_item)
        {
          E_CHILD_WITH_UP
          free_production(myproduction);
          return;
        }
        free_production(myproduction);
      }
      else if(!strcmp(adms_admsttransform_valueof_admstname(mychild),"admst:otherwise"))
      {
        E_CHILD_WITH_UP
        return;
      }
      else
        adms_message_fatal("%s: %s admst transform unexpected",
          adms_admsttransform_getuid(myadmsttransform),adms_admsttransform_getuid(mychild))
    }
    return;
  }
  else if(T(admst:if))
  {
    p_production myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_test(myadmsttransform));
    GSList*myl=myproduction->_curadmstlist;
    if(myl&&adms_admst(myl->data)->_item)/*list is not empty and its first el. has non null item*/
      E_WITH_UP
    free_production(myproduction);
  }
  else if(T(admst:return))
  {
    char*myname=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_name(myadmsttransform),NULL);
    char*myvalue=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_value(myadmsttransform),NULL);
    p_attribute myattribute=adms_attribute_new(myname);
    p_instanceofadmsttransform myinstanceofadmsttransform=curTemplateList?curTemplateList->data:NULL;
    adms_attribute_valueto_value(myattribute,myvalue);
    if(myinstanceofadmsttransform)
      adms_instanceofadmsttransform_list_return_prepend_once_or_abort(myinstanceofadmsttransform,myattribute);
    else
      adms_message_fatal("admst:return only allowed inside admst:template - see %s\n",h(adms_adms(myadmsttransform)))
  }
  else if(T(admst:apply-template)|T(admst:apply-templates))
  {
    GSList *l;
    p_admsttransform mytemplate=NULL;
    char*match=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_match(myadmsttransform),NULL);
    for(l=Templates;l&&!mytemplate;l=l->next)
    {
      if(!strcmp(adms_admsttransform_valueof_match(l->data),match))
        mytemplate=adms_admsttransform(l->data);
    }
    if(mytemplate)
    {
      p_instanceofadmsttransform myinstanceofadmsttransform=adms_instanceofadmsttransform_new(mytemplate);
      qpush(&curTemplateList,myinstanceofadmsttransform);
      FOREACH_ADMST(select)
      {
        p_admst myadmst=adms_admst(myl->data);
        if(adms_admst_valueof_item(myadmst))
        {
          E_TEMPLATE
          while(adms_instanceofadmsttransform_valueof_variable(myinstanceofadmsttransform))
          {
            p_admstvariable myadmstvariable=adms_instanceofadmsttransform_valueof_variable(myinstanceofadmsttransform)->data;
            adms_admstvariable_free(myadmstvariable);
            adms_instanceofadmsttransform_valueto_variable(myinstanceofadmsttransform,adms_instanceofadmsttransform_valueof_variable(myinstanceofadmsttransform)->next);
          }
        }
      }
      qpull(&curTemplateList);
      qpush(&curTemplateInsideApplyTemplate,myinstanceofadmsttransform);
      FOREACH_ADMST_AGAIN(select)
      {
        p_admst myadmst=adms_admst(myl->data);
        E_
      }
      for(l=myinstanceofadmsttransform->_return;l;l=l->next)
      {
        p_attribute myattribute=adms_attribute(l->data);
        free(myattribute->_name);
        free(myattribute->_value);
      }
      adms_instanceofadmsttransform_free(myinstanceofadmsttransform);
      qpull(&curTemplateInsideApplyTemplate);
      free_production(myproduction);
    }
    else
    {
      char*required=NULL;
      if(adms_admsttransform_valueof_required(myadmsttransform))
        required=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_required(myadmsttransform),NULL);
      if(required&&!strcmp(required,"yes"))
      {
        adms_message_fatal_continue("Template not found:\n")
        adms_message_fatal_continue("  <admst:template match=\"%s\"/>\n",match)
        adms_message_fatal("  see:  %s\n",adms_admsttransform_getuid(myadmsttransform))
      }
    }
    predicate_free(match);
  }
  else if(T(admst:variable))
  {
    p_instanceofadmsttransform myinstanceofadmsttransform=curTemplateList?curTemplateList->data:NULL;
    p_admstvariable myadmstvariable;
    char*name=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_name(myadmsttransform),NULL);
    if(myinstanceofadmsttransform&&(myadmstvariable=adms_instanceofadmsttransform_list_variable_lookup_by_id(myinstanceofadmsttransform,name)))
      free(name);
    else if(myadmstvariable=adms_admsmain_list_variable_lookup_by_id(adms_get_admsmain(),name))
      free(name);
    else if(myinstanceofadmsttransform)
      myadmstvariable=adms_instanceofadmsttransform_list_variable_prepend_by_id(myinstanceofadmsttransform,name);
    else
      myadmstvariable=adms_admsmain_list_variable_prepend_by_id(adms_get_admsmain(),name);
    if(adms_admsttransform_valueof_select(myadmsttransform))
    {
      int isstring;
      char*newvalue=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_select(myadmsttransform),&isstring);
      char*previous_svalue=adms_admstvariable_valueof_svalue(myadmstvariable);
      p_adms previous_evalue=adms_admstvariable_valueof_evalue(myadmstvariable);
      if(isstring)
      {
        if(previous_evalue)
        {
          adms_message_fatal_continue ("type of previous admst variable value does not match current type (new: string old: adms-element )\n");
          adms_message_fatal ("see %s\n",h(adms_adms(myadmsttransform)));
        }
        adms_admstvariable_valueto_svalue(myadmstvariable,newvalue);
        adms_admstvariable_valueto_evalue(myadmstvariable,NULL);
      }
      else
      {
        if(previous_svalue)
        {
          adms_message_fatal_continue ("type of previous admst variable value does not match current type (new: adms-element old: string)\n");
          adms_message_fatal ("see %s\n",h(adms_adms(myadmsttransform)));
        }
        adms_admstvariable_valueto_svalue(myadmstvariable,NULL);
        adms_admstvariable_valueto_evalue(myadmstvariable,adms_adms(newvalue));
      }
      free(previous_svalue);
    }
    else
    {
      char*previous_svalue=adms_admstvariable_valueof_svalue(myadmstvariable);
      adms_admstvariable_valueto_evalue(myadmstvariable,NULL);
      adms_admstvariable_valueto_svalue(myadmstvariable,NULL);
      free(previous_svalue);
    }
  }
  else if(T(admst:text))
  {
    adms_admsstack_printf(myadmsttransform,adms_admsttransform_valueof_format(myadmsttransform));
  }
  else if(T(admst:new))
  {
    p_admst myadmst=adms_admst_new(myadmsttransform,myup,g_strdup("?"));
    char** arguments;
    int size=0;
    int i;
    p_adms *Arguments;
    p_new new=adms_valueof_new(myadmsttransform);
    myadmst->_absolute=myadmst;
    arguments=g_strsplit (adms_admsttransform_valueof_arguments(myadmsttransform),",",-1);
    /*size=g_strv_length (arguments);*/ while (arguments[size]) ++size;
    Arguments=g_new0(p_adms,size);
    for(i=0;i<size;i++)
      Arguments[i]=adms_adms(adms_admsstack_sprintf(myadmsttransform,arguments[i],NULL));
    adms_admst_valueto_item(myadmst,new(Arguments));
    adms_admst_valueto_datatypename(myadmst,adms_adms_fromstring_datatypename_impl(myadmsttransform,adms_admsttransform_valueof_datatype(myadmsttransform)));
    E_
    g_strfreev (arguments);
    adms_admst_free(myadmst);
  }
  else if(T(admst:pull))
  {
    FOREACH_ADMST(select)
    {
    p_admst myadmst=adms_admst(myl->data);
    GSList*mylist=(GSList*)adms_adms_valueof(adms_admst_valueof_previous(myadmst),adms_admst_valueof_item(adms_admst_valueof_previous(myadmst)),adms_admst_valueof_attributename(myadmst));
    SIZE_list(myadmst)
    qpull(&mylist);
    adms_valueto(adms_admst_valueof_previous(myadmst),adms_admst_valueof_attributename(myadmst),(p_adms)mylist);
    }
    free_production(myproduction);
  }
  else if(T(admst:push))
  {
/*fixme: curadmstList can not be used*/
    p_production myproduction;
    p_production myproductioninto=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_into(myadmsttransform));
    p_admst myadmstinto=myproductioninto->_admstaslist;
    if(myadmstinto&&(adms_admst_valueof_datatypefamily(myadmstinto)==adms_admst_enumeration_datatypefamily_reference)
       &&(adms_admst_valueof_size(myadmstinto)==adms_admst_enumeration_size_list))
      myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_select(myadmsttransform));
    else
    {
      adms_message_fatal_continue ("value of 'into' should be a list of adms items\n");
      adms_message_fatal ("see %s\n",h(adms_adms(myadmsttransform)));
    }
    GSList*mylistinto=(GSList*)adms_adms_valueof(adms_admst_valueof_previous(myadmstinto),adms_admst_valueof_item(adms_admst_valueof_previous(myadmstinto)),adms_admst_valueof_attributename(myadmstinto));
    if(myproduction->_admstaslist)
    {
      GSList* listPtr;
      p_admst myadmstselect=myproduction->_admstaslist;
      GSList*mylistselect=(GSList*)adms_adms_valueof(adms_admst_valueof_previous(myadmstselect),adms_admst_valueof_item(adms_admst_valueof_previous(myadmstselect)),adms_admst_valueof_attributename(myadmstselect));
      for(listPtr=mylistinto;listPtr;listPtr=listPtr->next)
        adms_adms(listPtr->data)->_seen=adms_adms_enumeration_seen_yes;
      for(listPtr=mylistselect;listPtr;listPtr=listPtr->next)
      {
        if(adms_adms(listPtr->data)->_seen==adms_adms_enumeration_seen_no)
          mylistinto=g_slist_prepend(mylistinto,listPtr->data);
        adms_adms(listPtr->data)->_seen=adms_adms_enumeration_seen_yes;
      }
      for(listPtr=mylistinto;listPtr;listPtr=listPtr->next)
        adms_adms(listPtr->data)->_seen=adms_adms_enumeration_seen_no;
      adms_valueto(adms_admst_valueof_previous(myadmstinto),adms_admst_valueof_attributename(myadmstinto),(p_adms)mylistinto);
    }
    else if(adms_admsttransform_valueof_onduplicate(myadmsttransform)&&!strcmp(adms_admsttransform_valueof_onduplicate(myadmsttransform),"ignore"))
    {
      int notfound=1;
      GSList*myl=myproduction->_curadmstlist;
      if(adms_admst_valueof_datatypefamily(adms_admst(myl->data))==adms_admst_enumeration_datatypefamily_reference)
      {
        GSList* listPtr;
        p_cmp cmp=adms_valueof_cmp(myadmstinto);
        for(listPtr=mylistinto;listPtr&&notfound;listPtr=listPtr->next)
        {
          if(!cmp(adms_adms(listPtr->data),adms_admst_valueof_item(adms_admst(myl->data))))
          {
            p_admst myabsoluteadmst=adms_admst_valueof_absolute(adms_admst(myl->data));
            adms_admst_valueto_item(myabsoluteadmst,listPtr->data);
            adms_admst_valueto_item(adms_admst(myl->data),listPtr->data);
            if(listPtr->data!=adms_admst_valueof_item(adms_admst(myl->data)))
              free(adms_admst_valueof_item(adms_admst(myl->data)));
            notfound=0;
          }
        }
        if(notfound)
        {
          mylistinto=g_slist_prepend(mylistinto,adms_admst_valueof_item(adms_admst(myl->data)));
          adms_valueto(adms_admst_valueof_previous(myadmstinto),adms_admst_valueof_attributename(myadmstinto),(p_adms)mylistinto);
        }
      }
      else
      {
        adms_message_fatal_continue ("value of 'select' should be a reference to an adms element\n");
        adms_message_fatal ("see %s\n",h(adms_adms(myadmsttransform)));
      }
    }
    else
    {
      if(!myproduction->_curadmstlist||!myproduction->_curadmstlist->data)
      {
        adms_message_fatal_continue ("value of 'select' is empty\n");
        adms_message_fatal ("see %s\n",h(adms_adms(myadmsttransform)));
      }
      mylistinto=g_slist_prepend(mylistinto,adms_admst_valueof_item(adms_admst(myproduction->_curadmstlist->data)));
      adms_valueto(adms_admst_valueof_previous(myadmstinto),adms_admst_valueof_attributename(myadmstinto),(p_adms)mylistinto);
    }
    free_production(myproduction);
    free_production(myproductioninto);
  }
  else if(T(admst:reset))
  {
    p_production myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_select(myadmsttransform));
    GSList*myl=myproduction->_curadmstlist;
    if(myl)
    {
      p_admst myadmst=adms_admst(myl->data);
      p_adms pitem=adms_admst_valueof_item(adms_admst_valueof_previous(myadmst));
      if(_ISSCALAR)
      {
        if((adms_admst_valueof_datatypename(myadmst)==adms_admst_enumeration_datatypename_string))
          adms_valueto(adms_admst_valueof_previous(myadmst),adms_admst_valueof_attributename(myadmst),(p_adms)"");
        else
          adms_valueto(adms_admst_valueof_previous(myadmst),adms_admst_valueof_attributename(myadmst),NULL);
      }
      for(;myl;myl=myl->next)
      {
        p_admst myadmst=adms_admst(myl->data);
      }
    }
    free_production(myproduction);
  }
  else if(T(admst:value-to))
  {
    FOREACH_ADMST(select)
    {
      p_admst myadmst=adms_admst(myl->data);
      p_adms pitem=adms_admst_valueof_item(adms_admst_valueof_previous(myadmst));
      if((adms_admst_valueof_datatypename(myadmst)==adms_admst_enumeration_datatypename_enumeration))
      {
        int eval=((p_valueofstring) (adms_admst_valueof_fromstring(myadmst)))(myadmsttransform,adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_value(myadmsttransform),NULL));
        ((p_setany)adms_admst_valueof_valueto(myadmst))(pitem,(gpointer)eval);
      }
      else
        adms_valueto(adms_admst_valueof_previous(myadmst),adms_admst_valueof_attributename(myadmst),(p_adms)adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_value(myadmsttransform),NULL));
    }
    free_production(myproduction);
  }
  else if(T(admst:count))
  {
    p_production myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_select(myadmsttransform));
    p_admst myadmst=adms_admst_new(myproduction->_admsttransform,myup,g_strdup("admst:count"));
    myadmst->_datatypefamily=adms_admst_enumeration_datatypefamily_basictype;
    myadmst->_datatypename=adms_admst_enumeration_datatypename_integer;
    myadmst->_absolute=myadmst;
    myadmst->_item=GINT_TO_POINTER(g_slist_length(myproduction->_curadmstlist));
    qpush(&Get,myadmst);
    myproduction->_curadmstlist=NULL;
    free_production(myproduction);
  }
  else if(T(admst:reverse))
  {
    p_production myproduction=adms_admstpath_evaluate(myadmsttransform,myup,adms_admsttransform_valueof_select(myadmsttransform));
    p_admst myadmst=myproduction->_admstaslist;
    if(myadmst)
    {
      GSList*mylist=(GSList*)adms_adms_valueof(adms_admst_valueof_previous(myadmst),adms_admst_valueof_item(adms_admst_valueof_previous(myadmst)),adms_admst_valueof_attributename(myadmst));
      mylist=g_slist_reverse(mylist);
      adms_valueto(adms_admst_valueof_previous(myadmst),adms_admst_valueof_attributename(myadmst),(p_adms)mylist);
    }
    free_production(myproduction);
  }
  else if(T(admst:open))
  {
    char*filename=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_file(myadmsttransform),NULL);
    FILE *ofh=adms_file_open_write (filename,__FUNCTION__);
    if(ofh)
      adms_file_setfile_output (ofh);
    else
     adms_message_fatal("%s: can't open file. select stdout\n",adms_admsttransform_getuid(myadmsttransform))
    E_WITH_UP
    adms_file_close_output ();
    adms_file_setfile_output (stdout);
    free (filename);
  }
  else if(T(admst:setenv))
  {
    if(FALSE==g_setenv(
      adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_name(myadmsttransform),NULL),
      adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_value(myadmsttransform),NULL),TRUE))
      adms_message_fatal("%s: failed to set shell variable %s to %s\n",adms_admsttransform_getuid(myadmsttransform),
        adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_name(myadmsttransform),NULL),
        adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_value(myadmsttransform),NULL));
  }
  else if(T(admst:getenv))
  {
    p_admst myadmst=adms_admst_new(myadmsttransform,myup,g_strdup("admst:getenv"));
    qpush(&Get,myadmst);
  }
  else if(T(admst:copy))
  {
    char*from=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_from(myadmsttransform),NULL);
    char*to=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_to(myadmsttransform),NULL);
    char*fromOS=adms_file_getpathname(from);
    char*toOS=adms_file_getpathname(to);
    if(g_file_test (toOS, G_FILE_TEST_IS_DIR)==FALSE)
      adms_message_fatal("%s: to=`%s' invalid directory\n",adms_admsttransform_getuid (myadmsttransform),toOS)
    else if(g_file_test (fromOS, G_FILE_TEST_EXISTS)==FALSE)
      adms_message_fatal("%s: from=`%s' file not found\n",adms_admsttransform_getuid (myadmsttransform),fromOS)
    else if(g_file_test (fromOS, G_FILE_TEST_IS_REGULAR)==FALSE)
      adms_message_fatal("%s: from=`%s' not regular file\n",adms_admsttransform_getuid (myadmsttransform),fromOS)
    else
    {
      char*dirname=g_path_get_dirname (fromOS);
      char*basename=g_path_get_basename (fromOS);
      if(!strcmp(dirname,toOS))
        adms_message_fatal("%s: file '%s' copied to itself!\n",adms_admsttransform_getuid(myadmsttransform),fromOS)
      else
      {
        FILE*ifh=adms_file_open_read (fromOS,__FUNCTION__);
        if(ifh)
        {
          char*tofile=g_build_filename (toOS, basename, NULL);
          FILE*ofh=adms_file_open_write (tofile,__FUNCTION__);
          free (basename);
          if(ofh)
          {
             char c;
             adms_message_info(".... copying setup file: %s --> %s\n", fromOS, tofile)
             while ((c=getc (ifh)) && !feof (ifh))
               putc (c, ofh);
             fclose (ofh);
          }
          else
            adms_message_fatal("%s: to=`%s' cannot write file\n",adms_admsttransform_getuid(myadmsttransform),toOS)
          free (tofile);
          fclose (ifh);
        }
        else
          adms_message_fatal("%s: from=`%s' can't open file\n",adms_admsttransform_getuid(myadmsttransform),fromOS)
      }
    }
    predicate_free(from);
    predicate_free(to);
  }
  else if(T(admst:assert))
  {
    FOREACH_ADMST(test)
    {
      p_admst myadmst=adms_admst(myl->data);
      if(!adms_admst_valueof_item(myadmst))
      {
        char*text=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_format(myadmsttransform),NULL);
        adms_message_fatal_continue ("Died at assert: %s",text);
        adms_message_fatal ("see %s\n",h(adms_adms(myadmsttransform)));
      }
    }
    free_production(myproduction);
  }
  else if(T(admst:message))
  {
    char*text=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_format(myadmsttransform),NULL);
    adms_message_info ("%s",text);
    free(text);
  }
  else if(T(admst:warning))
  {
    char*text=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_format(myadmsttransform),NULL);
    adms_message_warning_continue ("%s",text);
    adms_message_warning ("see %s\n",h(adms_adms(myadmsttransform)));
    free(text);
  }
  else if(T(admst:error))
  {
    char*text=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_format(myadmsttransform),NULL);
    adms_message_error_continue ("%s",text);
    adms_message_error ("see %s\n",h(adms_adms(myadmsttransform)));
    free(text);
  }
  else if(T(admst:fatal))
  {
    char*text=adms_admsstack_sprintf(myadmsttransform,adms_admsttransform_valueof_format(myadmsttransform),NULL);
    adms_message_fatal_continue ("%s",text);
    adms_message_fatal ("see %s\n",h(adms_adms(myadmsttransform)));
  }
  else
    adms_message_fatal ("%s: unexpected transform\n",adms_admsttransform_getuid (myadmsttransform))
}
static void callTemplate(p_admst myadmst,p_adms myelement)
{
  const char*mydatatypename=adms_adms_tostring_datatypename_impl(
    adms_admst_valueof_admsttransform(myadmst),adms_adms_valueof_datatypename(myelement));
  GSList*l=Templates; for(;l;l=l->next)
  {
    if(!strcmp(adms_admsttransform_valueof_match(l->data),mydatatypename))
    {
      p_admsttransform myadmsttransform=adms_admsttransform(l->data);
      p_admst myadmst=adms_admst_new(myadmsttransform,NULL,g_strdup(mydatatypename));
      adms_admst_valueto_item(myadmst,myelement);
      adms_admst_valueto_datatypename(myadmst,adms_adms_valueof_datatypename(myelement));
      p_instanceofadmsttransform myinstanceofadmsttransform=adms_instanceofadmsttransform_new(myadmsttransform);
      qpush(&curTemplateList,myinstanceofadmsttransform);
      E_
      while(adms_instanceofadmsttransform_valueof_variable(myinstanceofadmsttransform))
      {
        p_admstvariable myadmstvariable=adms_instanceofadmsttransform_valueof_variable(myinstanceofadmsttransform)->data;
        adms_admstvariable_free(myadmstvariable);
        adms_instanceofadmsttransform_valueto_variable(myinstanceofadmsttransform,adms_instanceofadmsttransform_valueof_variable(myinstanceofadmsttransform)->next);
      }
      adms_instanceofadmsttransform_free(myinstanceofadmsttransform);
      qpull(&curTemplateList);
      adms_admst_free(myadmst);
      return;
    }
  }
  adms_message_fatal_continue("Template not found:\n")
  adms_message_fatal_continue("  <admst:template match=\"%s\"/>\n",mydatatypename)
  adms_message_fatal("  see:  %s\n",adms_admsttransform_getuid(adms_admst_valueof_admsttransform(myadmst)))
}

void adms_xml_load_xml_admsttransform_from_file (const char*filename)
{
  GMarkupParseContext *context;
  GSList *l;
  gsize length;
  GError *error=NULL;
  char*contents;
  char*admsfilename=adms_file_getpathname(filename);
  if(g_file_test (filename,G_FILE_TEST_IS_REGULAR))
  {
    qpush(&admstfileList,admsfilename);
    if(!g_file_get_contents (admsfilename, &contents, &length, &error))
      adms_message_fatal("%s [real path name: %s]\n",error->message,admsfilename)
    context=g_markup_parse_context_new (&parser, 0, NULL, NULL);
    if(!g_markup_parse_context_parse (context, contents, length, NULL))
    {
      GETTRANSFORM(myadmsttransform)
      adms_message_fatal_continue("xml parse context failed %s [real path name: %s]\n",admstfile,admsfilename)
      if(myadmsttransform)
        adms_message_fatal("latest transform seen %s\n",h(adms_adms(myadmsttransform)))
    }
    if(!g_markup_parse_context_end_parse (context, NULL))
    {
      GETTRANSFORM(myadmsttransform)
      adms_message_fatal_continue("xml end parse context failed %s [real path name: %s]\n",admstfile,admsfilename)
      if(myadmsttransform)
        adms_message_fatal("latest transform seen %s\n",h(adms_adms(myadmsttransform)))
    }
    g_markup_parse_context_free (context);
    free(contents);
    adms_message_debug("evaluate xml script (%s)\n", filename)
    l=Transform; while(l)
    {
      p_admst myadmst=adms_admst_new(adms_admsttransform(l->data),NULL,g_strdup("/"));
      adms_admst_valueto_item(myadmst,adms_adms(adms_get_admsmain()));
      adms_admst_valueto_datatypename(myadmst,adms_admst_enumeration_datatypename_admsmain);
      adms_admst_valueto_absolute(myadmst,myadmst);
      adms_admst_evaluate(adms_admsttransform(l->data),myadmst);
      l=l->next;
      adms_admst_free(myadmst);
    }
    if(Get)
    {
      p_admst latestgetadmst=(p_admst) qgetdata(Get);
      adms_message_fatal("Get has %i element(s) left - should be empty\n ... see transform: %s\n",
        g_slist_length (Get),adms_admst_getuid(latestgetadmst));
    }
    qpull(&admstfileList);
    g_slist_free(Transform); Transform=NULL;
  }
  else
    adms_message_warning("%s: cannot open file - shell variable 'adms_implicit_transforms' ignored!\n",admsfilename)
}
