#!perl -W

use warnings;
use XML::LibXML;

my $top_srcdir=shift @ARGV;

my$xmlns="admstpath";
my%terminal;
sub productionsets
{
  my$document=shift;
  my($codeH,$codeC)=("","");
  foreach my$productionset($document->findnodes("/$xmlns/freegrammar/productionset"))
  {
    my@productions=$productionset->findnodes("production");
    my$name=$productionset->getAttribute("name");
    $codeH.="static _t_goto(adms_admstpath_goto_$name);\n";
    $codeC.="_t_goto(adms_admstpath_goto_$name)\n{\n";
    $codeC.="  GSList* mycuradmst_backup=adms_production_valueof_curadmstlist(myproduction);\n";
    $codeC.="  char* mystringposition_backup=adms_production_valueof_stringposition(myproduction);\n";
    $codeC.="  e_production_token mytoken_backup=adms_production_valueof_token(myproduction);\n";
    $codeC.="  char* mytokentext_backup=adms_production_valueof_tokentext(myproduction);\n";
    my$index=1;
    my$size=scalar(@productions);
    foreach my$production(@productions)
    {
      my@prodems=$production->findnodes("prodem");
      my$newsize=scalar(@prodems);
      my%index;
      my$newindex=1;
      my$nbterminal=0;
      my$indexterminal=0;
      map{$nbterminal++ if ($terminal{$_->getAttribute("name")} && ($terminal{$_->getAttribute("name")} eq "variable"))} @prodems;
      my$prodem0=$prodems[0];
      my$name0=$prodem0->getAttribute("name");
      $codeC.="  {\n";
      $codeC.="    char* mytext[$nbterminal];\n" if($nbterminal);
      foreach my$prodem(@prodems)
      {
        my$name=$prodem->getAttribute("name");
        if((defined $terminal{$name}) && ($terminal{$name} eq "constant"))
        {
          $codeC.="    if(adms_production_valueof_token(myproduction)==adms_production_enumeration_token_$name)\n";
          $codeC.="    {\n";
          $codeC.="      lexan(myproduction);\n";
        }
        elsif((defined $terminal{$name}) && ($terminal{$name} eq "variable"))
        {
          $codeC.="    if(adms_production_valueof_token(myproduction)==adms_production_enumeration_token_$name)\n";
          $codeC.="    {\n";
          $codeC.="      mytext[$indexterminal]=adms_production_valueof_tokentext(myproduction);\n";
          $codeC.="      lexan(myproduction);\n";
          $index{$name}=$indexterminal;
          $indexterminal++;
        }
        else
        {
          $codeC.="    if(adms_admstpath_goto_$name(myproduction))\n";
          $codeC.="    {\n";
        }
        my@semantics=$prodem->findnodes("semantic");
        foreach my$prodem (@semantics)
        {
          my$name=$prodem->getAttribute("name");
          my@code=$document->findnodes("/$xmlns/freegrammar/code[\@id='$name']");
          my$text="/*$name*/";
          $text.=$code[0]->textContent();
          $text=~s/^ */        /;
          $text=~s/\n */\n        /g;
          $text=~s/\n *$/\n/;
          $text=~s/\n *\n/\n/g;
          $text=~s/^ *\n//g;
          while($text=~m/(mytext\[([a-zA-Z_]+)_([0-9]+)\])/) {my$old=$1;my$new="mytext\[".($index{$2}+$3)."\]"; $text=~s/\Q$old/$new/g;}
          $codeC.=$text;
        }
        if($newindex==scalar(@prodems))
        {
          $codeC.="      ";
          for(my$i=0;$i<$nbterminal;$i++)
          {
            $codeC.="free(mytext[$i]); ";
          }
          $codeC.="\n";
          $codeC.="      return 1;/*reduced*/\n";
        }
        $newindex++;
      }
      $codeC.="  ";
      foreach my$prodem (@prodems)
      {
        $codeC.="}";
      }
      $codeC.="}\n";
      $codeC.="  lookahead_reset\n" if($index!=$size);
      $index++;
    }
    if($productionset->findnodes("empty"))
    {
      my@empty=$productionset->findnodes("empty");
      foreach my$prodem($empty[0]->findnodes("semantic"))
      {
        my$name=$prodem->getAttribute("name");
        my@code=$document->findnodes("/$xmlns/freegrammar/code[\@id='$name']");
        my$text="/*$name*/";
        $text.=$code[0]->textContent();
        $text=~s/^ */        /;
        $text=~s/\n */\n        /g;
        $text=~s/\n *$/\n/;
        $text=~s/\n *\n/\n/g;
        $text=~s/^ *\n//g;
        $codeC.=$text;
      }
      $codeC.="  lookahead_reset return 1; /*reduced empty rule*/\n";
      $codeC.="}\n";
    }
    else #not empty
    {
      $codeC.="  {\n";
      $codeC.="    adms_message_fatal(\"%s: %s: admst path not valid\\n\",\n";
      $codeC.="      adms_admsttransform_getuid(adms_production_valueof_admsttransform(myproduction)),\n";
      $codeC.="      adms_production_valueof_admstpath(myproduction))\n";
      $codeC.="  }\n";
      $codeC.="}\n";
    }
  }
  return($codeH,$codeC);
}
sub lexans
{
  my$document=shift;
  my@terminals=$document->findnodes("/$xmlns/freegrammar/terminal");
  my@regexp=$document->findnodes("/$xmlns/freegrammar/regexp");
  my($codeH,$codeC)=("","");
  my@ignored;
  $codeC.="void lexan(p_production myproduction)\n";
  $codeC.="{\n";
  $codeC.="    char* t=adms_production_valueof_stringposition(myproduction);\n";
  foreach my$terminal(@terminals)
  {
    if($terminal{$terminal->getAttribute("token")} eq "ignore")
    {
      push @ignored,"(*t=='".$terminal->getAttribute("regexp")."')";
    }
  }
  my$ignored=join "||",@ignored;
  $codeC.="    /*ignored*/\n";
  $codeC.="    while($ignored) t++;\n";
  $codeC.="    adms_production_valueto_stringposition(myproduction,t);\n";
  $codeC.="    if (0) {}\n";
  foreach my$terminal(@terminals)
  {
    if($terminal{$terminal->getAttribute("token")} eq "constant")
    {
      my$token=$terminal->getAttribute("token");
      my$regexp=$terminal->getAttribute("regexp");
      my@size=split "", $regexp;
      my$size=scalar(@size);
      $codeC.="    else if(!strncmp(t,\"$regexp\",$size))\n";
      $codeC.="    {\n";
      $codeC.="      t+=$size;\n";
      $codeC.="      adms_production_valueto_token(myproduction,adms_production_enumeration_token_$token);\n";
      $codeC.="    }\n";
    }
  }
  foreach my$regexp(@regexp)
  {
    my$verbatim=$regexp->textContent();
    $verbatim=~s/^\s*\n//;
    $verbatim=~s/\n\s*$/\n/;
    $verbatim=~s/\n\s*\n/\n/g;
    $codeC.=$verbatim;
  }
  $codeC.="    else\n";
  $codeC.="    {\n";
  $codeC.="      adms_message_fatal(\"%s: admst path not valid - unexpected string '%s'\\n\",
        adms_admsttransform_getuid(adms_production_valueof_admsttransform(myproduction)),
        adms_production_valueof_admstpath(myproduction))\n";
  $codeC.="    }\n";
  $codeC.="    adms_production_valueto_stringposition(myproduction,t);\n";
  $codeC.="    return;\n";
  $codeC.="}\n";
  return($codeH,$codeC);
}
sub mk_code
{
  my($codeH,$codeC)=("","");
  my@freegrammar=XML::LibXML->new->parse_file ("$top_srcdir/$xmlns.xml")->getDocumentElement->findnodes("/$xmlns/freegrammar");
  my$document=$freegrammar[0]->ownerDocument->getDocumentElement;
  foreach($document->findnodes("/$xmlns/freegrammar/terminal"))
  {
    my$token=$_->getAttribute("token");
    my$regexp=$_->getAttribute("regexp");
    my$ignore=$_->getAttribute("ignore");
    if((defined $ignore) && ($ignore eq 'yes'))
    {
      $terminal{$token}="ignore";
    }
    else
    {
      my@terminals=$document->findnodes("/$xmlns/freegrammar/regexp[\@id='$regexp']");
      if ($token eq "eos")
      {
        $terminal{$token}="eos";
      }
      elsif(@terminals)
      {
        $terminal{$token}="variable";
      }
      else
      {
        $terminal{$token}="constant";
      }
    }
  }
  my($Hlexan,$Clexan)=&lexans($document);
  my($Hparse,$Cparse)=&productionsets($document);
  my@headercode=$document->findnodes("/$xmlns/freegrammar/headercode");
  $codeC.=$headercode[0]->textContent()."\n";
  $codeH.=$Hlexan;$codeC.=$Clexan;
  $codeH.=$Hparse;$codeC.=$Cparse;
  my@maincode=$document->findnodes("/$xmlns/freegrammar/maincode");
  $codeC.=$maincode[0]->textContent()."\n";
  return($codeH,$codeC);
}
my$BUILDER="code automatically created by $0";
open CFILE,">${top_srcdir}/admsXml/xmlXpath.c";
my($H,$C)=&mk_code();
print CFILE "\n/* ------- $BUILDER -------------- */\n\n";
print CFILE $C;
close CFILE;
